// Type definitions for @carbon/pictograms-react 10.10
// Project: https://github.com/carbon-design-system/carbon/tree/master/packages/pictograms-react
// Definitions by: Eric Liu <https://github.com/metonym>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
// TypeScript Version: 3.8

export interface CarbonPictogramProps extends Omit<React.SVGProps<SVGElement>, 'tabIndex' | 'aria-hidden'> {
    'aria-hidden'?: string;
    'aria-label'?: string;
    'aria-labelledby'?: string;
    height?: number;
    preserveAspectRatio?: string;
    tabIndex?: string;
    title?: string;
    viewBox?: string;
    width?: number;
    xmlns?: string;
}

export type CarbonPictogramType = (props: CarbonPictogramProps) => React.FunctionComponentElement<CarbonPictogramProps>;

export const ActiveServer: CarbonPictogramType;
export const Advocate: CarbonPictogramType;
export const Agriculture: CarbonPictogramType;
export const AirConditioner: CarbonPictogramType;
export const Airplane: CarbonPictogramType;
export const Alarm: CarbonPictogramType;
export const AlchemyDataNews: CarbonPictogramType;
export const AlchemyLanguage: CarbonPictogramType;
export const AlchemyLanguageAlphabetAExpanded: CarbonPictogramType;
export const AlchemyVision: CarbonPictogramType;
export const Americas: CarbonPictogramType;
export const AmsterdamCanal: CarbonPictogramType;
export const AmsterdamFarm: CarbonPictogramType;
export const AmsterdamWindmill: CarbonPictogramType;
export const Analyze: CarbonPictogramType;
export const AnalyzesData: CarbonPictogramType;
export const Apartment: CarbonPictogramType;
export const Api: CarbonPictogramType;
export const AppDeveloper: CarbonPictogramType;
export const Apple: CarbonPictogramType;
export const Application: CarbonPictogramType;
export const Archive: CarbonPictogramType;
export const AsiaAustralia: CarbonPictogramType;
export const AugmentedReality: CarbonPictogramType;
export const Austin: CarbonPictogramType;
export const AutomateModularManagement: CarbonPictogramType;
export const Automobile: CarbonPictogramType;
export const Bag: CarbonPictogramType;
export const Bangalore: CarbonPictogramType;
export const Bee: CarbonPictogramType;
export const BeijingMunicipal: CarbonPictogramType;
export const BeijingTower: CarbonPictogramType;
export const BerlinBrandenburg: CarbonPictogramType;
export const BerlinBrandenburgGate: CarbonPictogramType;
export const BerlinCathedral: CarbonPictogramType;
export const BerlinTower: CarbonPictogramType;
export const Bicycle: CarbonPictogramType;
export const Blockchain: CarbonPictogramType;
export const BoxPlot: CarbonPictogramType;
export const Build: CarbonPictogramType;
export const Building: CarbonPictogramType;
export const Bulldozer: CarbonPictogramType;
export const Bus: CarbonPictogramType;
export const Cafe: CarbonPictogramType;
export const Calendar: CarbonPictogramType;
export const CalendarDate: CarbonPictogramType;
export const CalendarEvent: CarbonPictogramType;
export const Camera: CarbonPictogramType;
export const Capitol: CarbonPictogramType;
export const Care: CarbonPictogramType;
export const Cell: CarbonPictogramType;
export const ChartArea: CarbonPictogramType;
export const ChartBar: CarbonPictogramType;
export const ChartBubble: CarbonPictogramType;
export const ChartBubbleLine: CarbonPictogramType;
export const ChartCandlestick: CarbonPictogramType;
export const ChartErrorBar: CarbonPictogramType;
export const ChartEvaluation: CarbonPictogramType;
export const ChartHighLow: CarbonPictogramType;
export const ChartHistogram: CarbonPictogramType;
export const ChartLine: CarbonPictogramType;
export const ChartMultiLine: CarbonPictogramType;
export const ChartParallel: CarbonPictogramType;
export const ChartRadar: CarbonPictogramType;
export const ChartRiver: CarbonPictogramType;
export const ChartScatterplot: CarbonPictogramType;
export const ChartTSne: CarbonPictogramType;
export const Chart_3D: CarbonPictogramType;
export const Cherries: CarbonPictogramType;
export const ChipCircuit: CarbonPictogramType;
export const ChipCredit: CarbonPictogramType;
export const ChipDebit: CarbonPictogramType;
export const CirclePacking: CarbonPictogramType;
export const CloudAnalytics: CarbonPictogramType;
export const CloudAssets: CarbonPictogramType;
export const CloudBuilderProfessionalServices: CarbonPictogramType;
export const CloudComputing: CarbonPictogramType;
export const CloudDataServices: CarbonPictogramType;
export const CloudDownload: CarbonPictogramType;
export const CloudEcosystem: CarbonPictogramType;
export const CloudGuidelines: CarbonPictogramType;
export const CloudManagedServices: CarbonPictogramType;
export const CloudOracle: CarbonPictogramType;
export const CloudPartners: CarbonPictogramType;
export const CloudPlanning: CarbonPictogramType;
export const CloudSap: CarbonPictogramType;
export const CloudServices: CarbonPictogramType;
export const CloudServicesPricing: CarbonPictogramType;
export const CloudStorage: CarbonPictogramType;
export const CloudStrategy: CarbonPictogramType;
export const CloudTutorials: CarbonPictogramType;
export const CloudUpload: CarbonPictogramType;
export const CloudVmware: CarbonPictogramType;
export const Cloudy: CarbonPictogramType;
export const CloudyDewy: CarbonPictogramType;
export const CloudyHazy: CarbonPictogramType;
export const CloudyHumid: CarbonPictogramType;
export const CloudyPartial: CarbonPictogramType;
export const CloudyWindy: CarbonPictogramType;
export const CoatHanger: CarbonPictogramType;
export const CognosAnalytics: CarbonPictogramType;
export const College: CarbonPictogramType;
export const ConceptExpansion: CarbonPictogramType;
export const ConceptInsights: CarbonPictogramType;
export const Connect: CarbonPictogramType;
export const Console: CarbonPictogramType;
export const ConsoleWireless: CarbonPictogramType;
export const Construct: CarbonPictogramType;
export const Conversation: CarbonPictogramType;
export const CopenhagenPlanetarium: CarbonPictogramType;
export const CopenhagenSnekkja: CarbonPictogramType;
export const CreditCard: CarbonPictogramType;
export const Crop: CarbonPictogramType;
export const CustomerService: CarbonPictogramType;
export const DataBackup: CarbonPictogramType;
export const DataInsights: CarbonPictogramType;
export const DataProcessing: CarbonPictogramType;
export const DataStorage: CarbonPictogramType;
export const Delete: CarbonPictogramType;
export const DeliverInsights: CarbonPictogramType;
export const DeliveryTruck: CarbonPictogramType;
export const DesignAndDevelopment_01: CarbonPictogramType;
export const DesignAndDevelopment_02: CarbonPictogramType;
export const Desktop: CarbonPictogramType;
export const Devops: CarbonPictogramType;
export const Dialogue: CarbonPictogramType;
export const Digital: CarbonPictogramType;
export const Dining: CarbonPictogramType;
export const Dna: CarbonPictogramType;
export const DoNot: CarbonPictogramType;
export const Docker: CarbonPictogramType;
export const Doctor: CarbonPictogramType;
export const DocumentConversion: CarbonPictogramType;
export const DoorHandle: CarbonPictogramType;
export const Download: CarbonPictogramType;
export const DownloadAlt: CarbonPictogramType;
export const DubaiPalmIslands: CarbonPictogramType;
export const DubaiSkyscraper: CarbonPictogramType;
export const DublinBrewery: CarbonPictogramType;
export const DublinCastle: CarbonPictogramType;
export const DuplicateFile: CarbonPictogramType;
export const Education: CarbonPictogramType;
export const Electric: CarbonPictogramType;
export const ElectricCharge: CarbonPictogramType;
export const Elevator: CarbonPictogramType;
export const Embed: CarbonPictogramType;
export const Engine: CarbonPictogramType;
export const EnterpriseDesignThinking: CarbonPictogramType;
export const EnterpriseDesignThinkingAlt: CarbonPictogramType;
export const Envelope: CarbonPictogramType;
export const ErlenmeyerFlask: CarbonPictogramType;
export const EscalatorDown: CarbonPictogramType;
export const EscalatorUp: CarbonPictogramType;
export const EuropeAfrica: CarbonPictogramType;
export const ExpandHorz: CarbonPictogramType;
export const ExpandUser: CarbonPictogramType;
export const ExpandVert: CarbonPictogramType;
export const Export: CarbonPictogramType;
export const ExportAlt: CarbonPictogramType;
export const Eye: CarbonPictogramType;
export const FaceDissatisfied: CarbonPictogramType;
export const FaceNeutral: CarbonPictogramType;
export const FaceSatisfied: CarbonPictogramType;
export const FaceVeryDissatisfied: CarbonPictogramType;
export const FaceVerySatisfied: CarbonPictogramType;
export const Factory: CarbonPictogramType;
export const Farm: CarbonPictogramType;
export const Faucet: CarbonPictogramType;
export const Feedback: CarbonPictogramType;
export const FileBackup: CarbonPictogramType;
export const FileTransfer: CarbonPictogramType;
export const FinancialConsultant: CarbonPictogramType;
export const FinancialGain: CarbonPictogramType;
export const FinancialNews: CarbonPictogramType;
export const FireAlarm: CarbonPictogramType;
export const FireExtinguisher: CarbonPictogramType;
export const Firewall: CarbonPictogramType;
export const FlowChart: CarbonPictogramType;
export const FlowChartDetail: CarbonPictogramType;
export const Fog: CarbonPictogramType;
export const Folder: CarbonPictogramType;
export const Forklift: CarbonPictogramType;
export const FreeTrial: CarbonPictogramType;
export const Fuel: CarbonPictogramType;
export const Gear: CarbonPictogramType;
export const GlobalBusinessServices: CarbonPictogramType;
export const GlobalFinanceEuro: CarbonPictogramType;
export const GlobalFinanceSterling: CarbonPictogramType;
export const GlobalNetwork: CarbonPictogramType;
export const GlobalTechnologyServices: CarbonPictogramType;
export const Globe: CarbonPictogramType;
export const GlobeLocations: CarbonPictogramType;
export const Group: CarbonPictogramType;
export const Hail: CarbonPictogramType;
export const HailHeavy: CarbonPictogramType;
export const HailMixed: CarbonPictogramType;
export const Handicap: CarbonPictogramType;
export const HandicapActive: CarbonPictogramType;
export const HardDrive: CarbonPictogramType;
export const HardDriveNetwork: CarbonPictogramType;
export const HardIceCream: CarbonPictogramType;
export const Hazy: CarbonPictogramType;
export const Headphones: CarbonPictogramType;
export const Heart: CarbonPictogramType;
export const HeartHealth: CarbonPictogramType;
export const HeatMap: CarbonPictogramType;
export const HeatMap_02: CarbonPictogramType;
export const HighFive: CarbonPictogramType;
export const HomeFront: CarbonPictogramType;
export const HomeGarage: CarbonPictogramType;
export const HomeProfile: CarbonPictogramType;
export const Hospital: CarbonPictogramType;
export const Humid: CarbonPictogramType;
export const Hurricane: CarbonPictogramType;
export const HybridCloud: CarbonPictogramType;
export const HybridCloudServices: CarbonPictogramType;
export const IbmIx: CarbonPictogramType;
export const IbmZ: CarbonPictogramType;
export const Icon: CarbonPictogramType;
export const Idea: CarbonPictogramType;
export const Ideate: CarbonPictogramType;
export const Innovate: CarbonPictogramType;
export const Integration: CarbonPictogramType;
export const Intelligence: CarbonPictogramType;
export const Intercom: CarbonPictogramType;
export const IotMunich: CarbonPictogramType;
export const Java: CarbonPictogramType;
export const Javascript: CarbonPictogramType;
export const Justice: CarbonPictogramType;
export const KeyUsers: CarbonPictogramType;
export const KnowsDarkData: CarbonPictogramType;
export const Language: CarbonPictogramType;
export const LanguageTranslation: CarbonPictogramType;
export const LanguageTranslationAlphabetAExpanded: CarbonPictogramType;
export const Language_01: CarbonPictogramType;
export const Language_02: CarbonPictogramType;
export const Language_03: CarbonPictogramType;
export const Language_04: CarbonPictogramType;
export const Launch: CarbonPictogramType;
export const Lightning: CarbonPictogramType;
export const ListBullet: CarbonPictogramType;
export const ListCheckbox: CarbonPictogramType;
export const Location: CarbonPictogramType;
export const Lock: CarbonPictogramType;
export const LockAlt: CarbonPictogramType;
export const LockedNetwork: CarbonPictogramType;
export const LockedNetworkAlt: CarbonPictogramType;
export const London: CarbonPictogramType;
export const LondonBigBen: CarbonPictogramType;
export const LondonExpandedBase: CarbonPictogramType;
export const Lungs: CarbonPictogramType;
export const MachineLearning_01: CarbonPictogramType;
export const MachineLearning_02: CarbonPictogramType;
export const MachineLearning_03: CarbonPictogramType;
export const MachineLearning_04: CarbonPictogramType;
export const MachineLearning_05: CarbonPictogramType;
export const MachineLearning_06: CarbonPictogramType;
export const MadridCathedral: CarbonPictogramType;
export const MadridSkyscrapers: CarbonPictogramType;
export const MadridStatue: CarbonPictogramType;
export const Magnify: CarbonPictogramType;
export const Marketplace: CarbonPictogramType;
export const Mas: CarbonPictogramType;
export const MathCurve: CarbonPictogramType;
export const Maximize: CarbonPictogramType;
export const Medical: CarbonPictogramType;
export const MedicalCharts: CarbonPictogramType;
export const MedicalStaff: CarbonPictogramType;
export const Melbourne: CarbonPictogramType;
export const Meter: CarbonPictogramType;
export const MexicoCityAngelOfIndependence: CarbonPictogramType;
export const MexicoCityMuseoSoumaya: CarbonPictogramType;
export const Microorganisms: CarbonPictogramType;
export const Microscope: CarbonPictogramType;
export const MilanDuomoDiMilano: CarbonPictogramType;
export const MilanSkyscrapers: CarbonPictogramType;
export const Minimize: CarbonPictogramType;
export const MobileAdd: CarbonPictogramType;
export const MobileChat: CarbonPictogramType;
export const MobileDevices: CarbonPictogramType;
export const MobilePhone: CarbonPictogramType;
export const MortarAndPestle: CarbonPictogramType;
export const Moscow: CarbonPictogramType;
export const Mqa: CarbonPictogramType;
export const Multitask: CarbonPictogramType;
export const Munich: CarbonPictogramType;
export const NaturalLanguageClassifier: CarbonPictogramType;
export const Network: CarbonPictogramType;
export const NetworkServices: CarbonPictogramType;
export const Networking_01: CarbonPictogramType;
export const Networking_02: CarbonPictogramType;
export const Networking_03: CarbonPictogramType;
export const Networking_04: CarbonPictogramType;
export const Networking_05: CarbonPictogramType;
export const Nice: CarbonPictogramType;
export const NightClear: CarbonPictogramType;
export const NycBrooklyn: CarbonPictogramType;
export const NycManhattan: CarbonPictogramType;
export const NycManhattanAlt: CarbonPictogramType;
export const Office: CarbonPictogramType;
export const OilPump: CarbonPictogramType;
export const OilRig: CarbonPictogramType;
export const Overcast: CarbonPictogramType;
export const PaperClip: CarbonPictogramType;
export const Parliament: CarbonPictogramType;
export const PartnerRelationship: CarbonPictogramType;
export const Path: CarbonPictogramType;
export const Pattern: CarbonPictogramType;
export const Perfume: CarbonPictogramType;
export const Person_01: CarbonPictogramType;
export const Person_02: CarbonPictogramType;
export const Person_03: CarbonPictogramType;
export const Person_04: CarbonPictogramType;
export const Person_05: CarbonPictogramType;
export const Person_06: CarbonPictogramType;
export const Person_07: CarbonPictogramType;
export const Person_08: CarbonPictogramType;
export const Person_09: CarbonPictogramType;
export const PersonalityInsights: CarbonPictogramType;
export const PetriCulture: CarbonPictogramType;
export const PillBottle_01: CarbonPictogramType;
export const Pills: CarbonPictogramType;
export const Podcast: CarbonPictogramType;
export const Police: CarbonPictogramType;
export const PopulationDiagram: CarbonPictogramType;
export const Power: CarbonPictogramType;
export const Presentation: CarbonPictogramType;
export const Presenter: CarbonPictogramType;
export const Price: CarbonPictogramType;
export const Printer: CarbonPictogramType;
export const PrivateNetwork: CarbonPictogramType;
export const PrivateNetworkAlt: CarbonPictogramType;
export const PrivateNetworkAlt_01: CarbonPictogramType;
export const PrivateNetwork_01: CarbonPictogramType;
export const Progress: CarbonPictogramType;
export const Puzzle: CarbonPictogramType;
export const QQPlot: CarbonPictogramType;
export const Question: CarbonPictogramType;
export const QuestionAndAnswer: CarbonPictogramType;
export const Rainy: CarbonPictogramType;
export const RainyHeavy: CarbonPictogramType;
export const Rank: CarbonPictogramType;
export const Receipt: CarbonPictogramType;
export const Recycle: CarbonPictogramType;
export const Refinery: CarbonPictogramType;
export const Refresh: CarbonPictogramType;
export const RelationshipDiagram: CarbonPictogramType;
export const RelationshipExtraction: CarbonPictogramType;
export const Renew: CarbonPictogramType;
export const RenewTeam: CarbonPictogramType;
export const Repeat: CarbonPictogramType;
export const Report: CarbonPictogramType;
export const Reset: CarbonPictogramType;
export const ResetHybridCloud: CarbonPictogramType;
export const ResetSettings: CarbonPictogramType;
export const RetrieveAndRank: CarbonPictogramType;
export const RichTextFormat: CarbonPictogramType;
export const Robot: CarbonPictogramType;
export const Robotics: CarbonPictogramType;
export const Rome: CarbonPictogramType;
export const SaasEnablement: CarbonPictogramType;
export const SanFrancisco: CarbonPictogramType;
export const SanFranciscoFog: CarbonPictogramType;
export const SaoPaulo: CarbonPictogramType;
export const SaoPauloExpandedBase: CarbonPictogramType;
export const Satellite: CarbonPictogramType;
export const SatelliteDish: CarbonPictogramType;
export const Scale: CarbonPictogramType;
export const ScatterMatrix: CarbonPictogramType;
export const Seattle: CarbonPictogramType;
export const SecureData: CarbonPictogramType;
export const SecureProfile: CarbonPictogramType;
export const Security: CarbonPictogramType;
export const SecurityShield: CarbonPictogramType;
export const ServerRack: CarbonPictogramType;
export const Servers: CarbonPictogramType;
export const Shop: CarbonPictogramType;
export const ShoppingCart: CarbonPictogramType;
export const Shower: CarbonPictogramType;
export const Singapore: CarbonPictogramType;
export const SingleSignOn: CarbonPictogramType;
export const Slider: CarbonPictogramType;
export const Sneaker: CarbonPictogramType;
export const Snow: CarbonPictogramType;
export const SoftIceCream: CarbonPictogramType;
export const SoftlayerEnablement: CarbonPictogramType;
export const Solve: CarbonPictogramType;
export const Spaceship: CarbonPictogramType;
export const Speech: CarbonPictogramType;
export const SpeechAlphabetAExpanded: CarbonPictogramType;
export const SpeechToText: CarbonPictogramType;
export const Speedometer: CarbonPictogramType;
export const StairsPlanView: CarbonPictogramType;
export const StationaryBicycle: CarbonPictogramType;
export const Steel: CarbonPictogramType;
export const SteeringWheel: CarbonPictogramType;
export const Stethoscope: CarbonPictogramType;
export const Strategy: CarbonPictogramType;
export const StrategyDirect: CarbonPictogramType;
export const StrategyMove: CarbonPictogramType;
export const StrategyPlay: CarbonPictogramType;
export const Streamline: CarbonPictogramType;
export const Sunny: CarbonPictogramType;
export const SunnyHazy: CarbonPictogramType;
export const SupportServices: CarbonPictogramType;
export const SwipeLeft: CarbonPictogramType;
export const SwipeRight: CarbonPictogramType;
export const Tags: CarbonPictogramType;
export const Target: CarbonPictogramType;
export const TargetArea: CarbonPictogramType;
export const TelAviv: CarbonPictogramType;
export const Telecom: CarbonPictogramType;
export const Telephone: CarbonPictogramType;
export const Television: CarbonPictogramType;
export const TemperatureHigh: CarbonPictogramType;
export const TemperatureLow: CarbonPictogramType;
export const Tennis: CarbonPictogramType;
export const TestTubes: CarbonPictogramType;
export const TextToSpeech: CarbonPictogramType;
export const Time: CarbonPictogramType;
export const TimeLapse: CarbonPictogramType;
export const Toggle: CarbonPictogramType;
export const TokyoCherryBlossom: CarbonPictogramType;
export const TokyoGates: CarbonPictogramType;
export const TokyoTemple: CarbonPictogramType;
export const TokyoVolcano: CarbonPictogramType;
export const ToneAnalyzer: CarbonPictogramType;
export const Tools: CarbonPictogramType;
export const Tornado: CarbonPictogramType;
export const Toronto: CarbonPictogramType;
export const Touch: CarbonPictogramType;
export const TouchGesture: CarbonPictogramType;
export const TouchId: CarbonPictogramType;
export const TouchScreen: CarbonPictogramType;
export const TouchSwipe: CarbonPictogramType;
export const Tractor: CarbonPictogramType;
export const TradeoffAnalytics: CarbonPictogramType;
export const Train: CarbonPictogramType;
export const Transform: CarbonPictogramType;
export const Trash: CarbonPictogramType;
export const TreeDiagram: CarbonPictogramType;
export const TreeMap: CarbonPictogramType;
export const University: CarbonPictogramType;
export const Unlock: CarbonPictogramType;
export const UnlockAlt: CarbonPictogramType;
export const Upload: CarbonPictogramType;
export const UploadAlt: CarbonPictogramType;
export const UserAnalytics: CarbonPictogramType;
export const UserInsights: CarbonPictogramType;
export const UserSearch: CarbonPictogramType;
export const Vancouver: CarbonPictogramType;
export const Video: CarbonPictogramType;
export const VideoAlt: CarbonPictogramType;
export const VideoChat: CarbonPictogramType;
export const VideoPlay: CarbonPictogramType;
export const Virus: CarbonPictogramType;
export const Vision: CarbonPictogramType;
export const VisualInsights: CarbonPictogramType;
export const VisualRecognition: CarbonPictogramType;
export const Warning: CarbonPictogramType;
export const WarningAlt: CarbonPictogramType;
export const Washer: CarbonPictogramType;
export const WashingtonDc: CarbonPictogramType;
export const WashingtonDcCapitol: CarbonPictogramType;
export const WashingtonDcMonument: CarbonPictogramType;
export const WatsonAvatar: CarbonPictogramType;
export const Weather: CarbonPictogramType;
export const WebDeveloper: CarbonPictogramType;
export const Webcast: CarbonPictogramType;
export const Wheat: CarbonPictogramType;
export const Wifi: CarbonPictogramType;
export const WindPower: CarbonPictogramType;
export const Windows: CarbonPictogramType;
export const Windy: CarbonPictogramType;
export const Wine: CarbonPictogramType;
export const WirelessHome: CarbonPictogramType;
export const WirelessModem: CarbonPictogramType;
export const WordCloud: CarbonPictogramType;
export const WreckingBall: CarbonPictogramType;
export const Yoga_01: CarbonPictogramType;
export const Yoga_02: CarbonPictogramType;
export const Yoga_03: CarbonPictogramType;
export const Yoga_04: CarbonPictogramType;
