/* This is stub file for gapi.client.sheets definition tests */
/* IMPORTANT.
* This file was automatically generated by https://github.com/Maxim-Mazurok/google-api-typings-generator. Please do not edit it manually.
* In case of any problems please post issue to https://github.com/Maxim-Mazurok/google-api-typings-generator
**/
gapi.load('client', () => {
    /** now we can use gapi.client */
    gapi.client.load('sheets', 'v4', () => {
        /** now we can use gapi.client.sheets */

        /** don't forget to authenticate your client before sending any request to resources: */
        /** declare client_id registered in Google Developers Console */
        const client_id = '<<PUT YOUR CLIENT ID HERE>>';
        const scope = [
            /** See, edit, create, and delete all of your Google Drive files */
            'https://www.googleapis.com/auth/drive',
            /** View and manage Google Drive files and folders that you have opened or created with this app */
            'https://www.googleapis.com/auth/drive.file',
            /** See and download all your Google Drive files */
            'https://www.googleapis.com/auth/drive.readonly',
            /** See, edit, create, and delete your spreadsheets in Google Drive */
            'https://www.googleapis.com/auth/spreadsheets',
            /** View your Google Spreadsheets */
            'https://www.googleapis.com/auth/spreadsheets.readonly',
        ];
        const immediate = false;
        gapi.auth.authorize({ client_id, scope, immediate }, authResult => {
            if (authResult && !authResult.error) {
                /** handle successful authorization */
                run();
            } else {
                /** handle authorization error */
            }
        });
    });

    async function run() {
        /**
         * Applies one or more updates to the spreadsheet.
         *
         * Each request is validated before
         * being applied. If any request is not valid then the entire request will
         * fail and nothing will be applied.
         *
         * Some requests have replies to
         * give you some information about how
         * they are applied. The replies will mirror the requests.  For example,
         * if you applied 4 updates and the 3rd one had a reply, then the
         * response will have 2 empty replies, the actual reply, and another empty
         * reply, in that order.
         *
         * Due to the collaborative nature of spreadsheets, it is not guaranteed that
         * the spreadsheet will reflect exactly your changes after this completes,
         * however it is guaranteed that the updates in the request will be
         * applied together atomically. Your changes may be altered with respect to
         * collaborator changes. If there are no collaborators, the spreadsheet
         * should reflect your changes.
         */
        await gapi.client.sheets.spreadsheets.batchUpdate({
            spreadsheetId: "Test string",
        }, {
            includeSpreadsheetInResponse: true,
            requests: [
                {
                    addBanding: {
                        bandedRange: {
                            bandedRangeId: 42,
                            columnProperties: {
                                firstBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                firstBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                footerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                footerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                headerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                headerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                secondBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                secondBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                            },
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            rowProperties: {
                                firstBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                firstBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                footerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                footerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                headerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                headerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                secondBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                secondBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                            },
                        },
                    },
                    addChart: {
                        chart: {
                            chartId: 42,
                            position: {
                                newSheet: true,
                                overlayPosition: {
                                    anchorCell: {
                                        columnIndex: 42,
                                        rowIndex: 42,
                                        sheetId: 42,
                                    },
                                    heightPixels: 42,
                                    offsetXPixels: 42,
                                    offsetYPixels: 42,
                                    widthPixels: 42,
                                },
                                sheetId: 42,
                            },
                            spec: {
                                altText: "Test string",
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                basicChart: {
                                    axis: [
                                        {
                                            format: {
                                                bold: true,
                                                fontFamily: "Test string",
                                                fontSize: 42,
                                                foregroundColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                foregroundColorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                italic: true,
                                                strikethrough: true,
                                                underline: true,
                                            },
                                            position: "Test string",
                                            title: "Test string",
                                            titleTextPosition: {
                                                horizontalAlignment: "Test string",
                                            },
                                            viewWindowOptions: {
                                                viewWindowMax: 42,
                                                viewWindowMin: 42,
                                                viewWindowMode: "Test string",
                                            },
                                        }                                    ],
                                    chartType: "Test string",
                                    compareMode: "Test string",
                                    domains: [
                                        {
                                            domain: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                            reversed: true,
                                        }                                    ],
                                    headerCount: 42,
                                    interpolateNulls: true,
                                    legendPosition: "Test string",
                                    lineSmoothing: true,
                                    series: [
                                        {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            lineStyle: {
                                                type: "Test string",
                                                width: 42,
                                            },
                                            series: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                            targetAxis: "Test string",
                                            type: "Test string",
                                        }                                    ],
                                    stackedType: "Test string",
                                    threeDimensional: true,
                                },
                                bubbleChart: {
                                    bubbleBorderColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    bubbleBorderColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    bubbleLabels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    bubbleMaxRadiusSize: 42,
                                    bubbleMinRadiusSize: 42,
                                    bubbleOpacity: 42,
                                    bubbleSizes: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    bubbleTextStyle: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                    domain: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    groupIds: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    legendPosition: "Test string",
                                    series: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                },
                                candlestickChart: {
                                    data: [
                                        {
                                            closeSeries: {
                                                data: {
                                                    sourceRange: {
                                                        sources: [
                                                            {
                                                                endColumnIndex: 42,
                                                                endRowIndex: 42,
                                                                sheetId: 42,
                                                                startColumnIndex: 42,
                                                                startRowIndex: 42,
                                                            }                                                        ],
                                                    },
                                                },
                                            },
                                            highSeries: {
                                                data: {
                                                    sourceRange: {
                                                        sources: [
                                                            {
                                                                endColumnIndex: 42,
                                                                endRowIndex: 42,
                                                                sheetId: 42,
                                                                startColumnIndex: 42,
                                                                startRowIndex: 42,
                                                            }                                                        ],
                                                    },
                                                },
                                            },
                                            lowSeries: {
                                                data: {
                                                    sourceRange: {
                                                        sources: [
                                                            {
                                                                endColumnIndex: 42,
                                                                endRowIndex: 42,
                                                                sheetId: 42,
                                                                startColumnIndex: 42,
                                                                startRowIndex: 42,
                                                            }                                                        ],
                                                    },
                                                },
                                            },
                                            openSeries: {
                                                data: {
                                                    sourceRange: {
                                                        sources: [
                                                            {
                                                                endColumnIndex: 42,
                                                                endRowIndex: 42,
                                                                sheetId: 42,
                                                                startColumnIndex: 42,
                                                                startRowIndex: 42,
                                                            }                                                        ],
                                                    },
                                                },
                                            },
                                        }                                    ],
                                    domain: {
                                        data: {
                                            sourceRange: {
                                                sources: [
                                                    {
                                                        endColumnIndex: 42,
                                                        endRowIndex: 42,
                                                        sheetId: 42,
                                                        startColumnIndex: 42,
                                                        startRowIndex: 42,
                                                    }                                                ],
                                            },
                                        },
                                        reversed: true,
                                    },
                                },
                                fontName: "Test string",
                                hiddenDimensionStrategy: "Test string",
                                histogramChart: {
                                    bucketSize: 42,
                                    legendPosition: "Test string",
                                    outlierPercentile: 42,
                                    series: [
                                        {
                                            barColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            barColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            data: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                        }                                    ],
                                    showItemDividers: true,
                                },
                                maximized: true,
                                orgChart: {
                                    labels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    nodeColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    nodeColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    nodeSize: "Test string",
                                    parentLabels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    selectedNodeColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    selectedNodeColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    tooltips: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                },
                                pieChart: {
                                    domain: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    legendPosition: "Test string",
                                    pieHole: 42,
                                    series: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    threeDimensional: true,
                                },
                                scorecardChart: {
                                    aggregateType: "Test string",
                                    baselineValueData: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    baselineValueFormat: {
                                        comparisonType: "Test string",
                                        description: "Test string",
                                        negativeColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        negativeColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        position: {
                                            horizontalAlignment: "Test string",
                                        },
                                        positiveColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        positiveColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        textFormat: {
                                            bold: true,
                                            fontFamily: "Test string",
                                            fontSize: 42,
                                            foregroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            foregroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            italic: true,
                                            strikethrough: true,
                                            underline: true,
                                        },
                                    },
                                    customFormatOptions: {
                                        prefix: "Test string",
                                        suffix: "Test string",
                                    },
                                    keyValueData: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    keyValueFormat: {
                                        position: {
                                            horizontalAlignment: "Test string",
                                        },
                                        textFormat: {
                                            bold: true,
                                            fontFamily: "Test string",
                                            fontSize: 42,
                                            foregroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            foregroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            italic: true,
                                            strikethrough: true,
                                            underline: true,
                                        },
                                    },
                                    numberFormatSource: "Test string",
                                    scaleFactor: 42,
                                },
                                subtitle: "Test string",
                                subtitleTextFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                subtitleTextPosition: {
                                    horizontalAlignment: "Test string",
                                },
                                title: "Test string",
                                titleTextFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                titleTextPosition: {
                                    horizontalAlignment: "Test string",
                                },
                                treemapChart: {
                                    colorData: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    colorScale: {
                                        maxValueColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        maxValueColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        midValueColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        midValueColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        minValueColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        minValueColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        noDataColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        noDataColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                    },
                                    headerColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    headerColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    hideTooltips: true,
                                    hintedLevels: 42,
                                    labels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    levels: 42,
                                    maxValue: 42,
                                    minValue: 42,
                                    parentLabels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    sizeData: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    textFormat: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                },
                                waterfallChart: {
                                    connectorLineStyle: {
                                        type: "Test string",
                                        width: 42,
                                    },
                                    domain: {
                                        data: {
                                            sourceRange: {
                                                sources: [
                                                    {
                                                        endColumnIndex: 42,
                                                        endRowIndex: 42,
                                                        sheetId: 42,
                                                        startColumnIndex: 42,
                                                        startRowIndex: 42,
                                                    }                                                ],
                                            },
                                        },
                                        reversed: true,
                                    },
                                    firstValueIsTotal: true,
                                    hideConnectorLines: true,
                                    series: [
                                        {
                                            customSubtotals: [
                                                {
                                                    dataIsSubtotal: true,
                                                    label: "Test string",
                                                    subtotalIndex: 42,
                                                }                                            ],
                                            data: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                            hideTrailingSubtotal: true,
                                            negativeColumnsStyle: {
                                                color: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                colorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                label: "Test string",
                                            },
                                            positiveColumnsStyle: {
                                                color: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                colorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                label: "Test string",
                                            },
                                            subtotalColumnsStyle: {
                                                color: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                colorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                label: "Test string",
                                            },
                                        }                                    ],
                                    stackedType: "Test string",
                                },
                            },
                        },
                    },
                    addConditionalFormatRule: {
                        index: 42,
                        rule: {
                            booleanRule: {
                                condition: {
                                    type: "Test string",
                                    values: [
                                        {
                                            relativeDate: "Test string",
                                            userEnteredValue: "Test string",
                                        }                                    ],
                                },
                                format: {
                                    backgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    backgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    borders: {
                                        bottom: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        left: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        right: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        top: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                    },
                                    horizontalAlignment: "Test string",
                                    hyperlinkDisplayType: "Test string",
                                    numberFormat: {
                                        pattern: "Test string",
                                        type: "Test string",
                                    },
                                    padding: {
                                        bottom: 42,
                                        left: 42,
                                        right: 42,
                                        top: 42,
                                    },
                                    textDirection: "Test string",
                                    textFormat: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                    textRotation: {
                                        angle: 42,
                                        vertical: true,
                                    },
                                    verticalAlignment: "Test string",
                                    wrapStrategy: "Test string",
                                },
                            },
                            gradientRule: {
                                maxpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                                midpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                                minpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                            },
                            ranges: [
                                {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                }                            ],
                        },
                    },
                    addDimensionGroup: {
                        range: {
                            dimension: "Test string",
                            endIndex: 42,
                            sheetId: 42,
                            startIndex: 42,
                        },
                    },
                    addFilterView: {
                        filter: {
                            criteria: {
                                A: {
                                    condition: {
                                        type: "Test string",
                                        values: [
                                            {
                                                relativeDate: "Test string",
                                                userEnteredValue: "Test string",
                                            }                                        ],
                                    },
                                    hiddenValues: [
                                        "Test string"                                    ],
                                    visibleBackgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleBackgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    visibleForegroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleForegroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                }                            },
                            filterViewId: 42,
                            namedRangeId: "Test string",
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            sortSpecs: [
                                {
                                    backgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    backgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    dimensionIndex: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    sortOrder: "Test string",
                                }                            ],
                            title: "Test string",
                        },
                    },
                    addNamedRange: {
                        namedRange: {
                            name: "Test string",
                            namedRangeId: "Test string",
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                        },
                    },
                    addProtectedRange: {
                        protectedRange: {
                            description: "Test string",
                            editors: {
                                domainUsersCanEdit: true,
                                groups: [
                                    "Test string"                                ],
                                users: [
                                    "Test string"                                ],
                            },
                            namedRangeId: "Test string",
                            protectedRangeId: 42,
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            requestingUserCanEdit: true,
                            unprotectedRanges: [
                                {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                }                            ],
                            warningOnly: true,
                        },
                    },
                    addSheet: {
                        properties: {
                            gridProperties: {
                                columnCount: 42,
                                columnGroupControlAfter: true,
                                frozenColumnCount: 42,
                                frozenRowCount: 42,
                                hideGridlines: true,
                                rowCount: 42,
                                rowGroupControlAfter: true,
                            },
                            hidden: true,
                            index: 42,
                            rightToLeft: true,
                            sheetId: 42,
                            sheetType: "Test string",
                            tabColor: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            tabColorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            title: "Test string",
                        },
                    },
                    addSlicer: {
                        slicer: {
                            position: {
                                newSheet: true,
                                overlayPosition: {
                                    anchorCell: {
                                        columnIndex: 42,
                                        rowIndex: 42,
                                        sheetId: 42,
                                    },
                                    heightPixels: 42,
                                    offsetXPixels: 42,
                                    offsetYPixels: 42,
                                    widthPixels: 42,
                                },
                                sheetId: 42,
                            },
                            slicerId: 42,
                            spec: {
                                applyToPivotTables: true,
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                columnIndex: 42,
                                dataRange: {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                },
                                filterCriteria: {
                                    condition: {
                                        type: "Test string",
                                        values: [
                                            {
                                                relativeDate: "Test string",
                                                userEnteredValue: "Test string",
                                            }                                        ],
                                    },
                                    hiddenValues: [
                                        "Test string"                                    ],
                                    visibleBackgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleBackgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    visibleForegroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleForegroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                },
                                horizontalAlignment: "Test string",
                                textFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                title: "Test string",
                            },
                        },
                    },
                    appendCells: {
                        fields: "Test string",
                        rows: [
                            {
                                values: [
                                    {
                                        dataValidation: {
                                            condition: {
                                                type: "Test string",
                                                values: [
                                                    {
                                                        relativeDate: "Test string",
                                                        userEnteredValue: "Test string",
                                                    }                                                ],
                                            },
                                            inputMessage: "Test string",
                                            showCustomUi: true,
                                            strict: true,
                                        },
                                        effectiveFormat: {
                                            backgroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            backgroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            borders: {
                                                bottom: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                left: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                right: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                top: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                            },
                                            horizontalAlignment: "Test string",
                                            hyperlinkDisplayType: "Test string",
                                            numberFormat: {
                                                pattern: "Test string",
                                                type: "Test string",
                                            },
                                            padding: {
                                                bottom: 42,
                                                left: 42,
                                                right: 42,
                                                top: 42,
                                            },
                                            textDirection: "Test string",
                                            textFormat: {
                                                bold: true,
                                                fontFamily: "Test string",
                                                fontSize: 42,
                                                foregroundColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                foregroundColorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                italic: true,
                                                strikethrough: true,
                                                underline: true,
                                            },
                                            textRotation: {
                                                angle: 42,
                                                vertical: true,
                                            },
                                            verticalAlignment: "Test string",
                                            wrapStrategy: "Test string",
                                        },
                                        effectiveValue: {
                                            boolValue: true,
                                            errorValue: {
                                                message: "Test string",
                                                type: "Test string",
                                            },
                                            formulaValue: "Test string",
                                            numberValue: 42,
                                            stringValue: "Test string",
                                        },
                                        formattedValue: "Test string",
                                        hyperlink: "Test string",
                                        note: "Test string",
                                        pivotTable: {
                                            columns: [
                                                {
                                                    groupRule: {
                                                        dateTimeRule: {
                                                            type: "Test string",
                                                        },
                                                        histogramRule: {
                                                            end: 42,
                                                            interval: 42,
                                                            start: 42,
                                                        },
                                                        manualRule: {
                                                            groups: [
                                                                {
                                                                    groupName: {
                                                                        boolValue: true,
                                                                        errorValue: {
                                                                            message: "Test string",
                                                                            type: "Test string",
                                                                        },
                                                                        formulaValue: "Test string",
                                                                        numberValue: 42,
                                                                        stringValue: "Test string",
                                                                    },
                                                                    items: [
                                                                        {
                                                                            boolValue: true,
                                                                            errorValue: {
                                                                                message: "Test string",
                                                                                type: "Test string",
                                                                            },
                                                                            formulaValue: "Test string",
                                                                            numberValue: 42,
                                                                            stringValue: "Test string",
                                                                        }                                                                    ],
                                                                }                                                            ],
                                                        },
                                                    },
                                                    label: "Test string",
                                                    repeatHeadings: true,
                                                    showTotals: true,
                                                    sortOrder: "Test string",
                                                    sourceColumnOffset: 42,
                                                    valueBucket: {
                                                        buckets: [
                                                            {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            }                                                        ],
                                                        valuesIndex: 42,
                                                    },
                                                    valueMetadata: [
                                                        {
                                                            collapsed: true,
                                                            value: {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            },
                                                        }                                                    ],
                                                }                                            ],
                                            criteria: {
                                                A: {
                                                    visibleValues: [
                                                        "Test string"                                                    ],
                                                }                                            },
                                            rows: [
                                                {
                                                    groupRule: {
                                                        dateTimeRule: {
                                                            type: "Test string",
                                                        },
                                                        histogramRule: {
                                                            end: 42,
                                                            interval: 42,
                                                            start: 42,
                                                        },
                                                        manualRule: {
                                                            groups: [
                                                                {
                                                                    groupName: {
                                                                        boolValue: true,
                                                                        errorValue: {
                                                                            message: "Test string",
                                                                            type: "Test string",
                                                                        },
                                                                        formulaValue: "Test string",
                                                                        numberValue: 42,
                                                                        stringValue: "Test string",
                                                                    },
                                                                    items: [
                                                                        {
                                                                            boolValue: true,
                                                                            errorValue: {
                                                                                message: "Test string",
                                                                                type: "Test string",
                                                                            },
                                                                            formulaValue: "Test string",
                                                                            numberValue: 42,
                                                                            stringValue: "Test string",
                                                                        }                                                                    ],
                                                                }                                                            ],
                                                        },
                                                    },
                                                    label: "Test string",
                                                    repeatHeadings: true,
                                                    showTotals: true,
                                                    sortOrder: "Test string",
                                                    sourceColumnOffset: 42,
                                                    valueBucket: {
                                                        buckets: [
                                                            {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            }                                                        ],
                                                        valuesIndex: 42,
                                                    },
                                                    valueMetadata: [
                                                        {
                                                            collapsed: true,
                                                            value: {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            },
                                                        }                                                    ],
                                                }                                            ],
                                            source: {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            },
                                            valueLayout: "Test string",
                                            values: [
                                                {
                                                    calculatedDisplayType: "Test string",
                                                    formula: "Test string",
                                                    name: "Test string",
                                                    sourceColumnOffset: 42,
                                                    summarizeFunction: "Test string",
                                                }                                            ],
                                        },
                                        textFormatRuns: [
                                            {
                                                format: {
                                                    bold: true,
                                                    fontFamily: "Test string",
                                                    fontSize: 42,
                                                    foregroundColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    foregroundColorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    italic: true,
                                                    strikethrough: true,
                                                    underline: true,
                                                },
                                                startIndex: 42,
                                            }                                        ],
                                        userEnteredFormat: {
                                            backgroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            backgroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            borders: {
                                                bottom: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                left: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                right: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                top: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                            },
                                            horizontalAlignment: "Test string",
                                            hyperlinkDisplayType: "Test string",
                                            numberFormat: {
                                                pattern: "Test string",
                                                type: "Test string",
                                            },
                                            padding: {
                                                bottom: 42,
                                                left: 42,
                                                right: 42,
                                                top: 42,
                                            },
                                            textDirection: "Test string",
                                            textFormat: {
                                                bold: true,
                                                fontFamily: "Test string",
                                                fontSize: 42,
                                                foregroundColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                foregroundColorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                italic: true,
                                                strikethrough: true,
                                                underline: true,
                                            },
                                            textRotation: {
                                                angle: 42,
                                                vertical: true,
                                            },
                                            verticalAlignment: "Test string",
                                            wrapStrategy: "Test string",
                                        },
                                        userEnteredValue: {
                                            boolValue: true,
                                            errorValue: {
                                                message: "Test string",
                                                type: "Test string",
                                            },
                                            formulaValue: "Test string",
                                            numberValue: 42,
                                            stringValue: "Test string",
                                        },
                                    }                                ],
                            }                        ],
                        sheetId: 42,
                    },
                    appendDimension: {
                        dimension: "Test string",
                        length: 42,
                        sheetId: 42,
                    },
                    autoFill: {
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        sourceAndDestination: {
                            dimension: "Test string",
                            fillLength: 42,
                            source: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                        },
                        useAlternateSeries: true,
                    },
                    autoResizeDimensions: {
                        dimensions: {
                            dimension: "Test string",
                            endIndex: 42,
                            sheetId: 42,
                            startIndex: 42,
                        },
                    },
                    clearBasicFilter: {
                        sheetId: 42,
                    },
                    copyPaste: {
                        destination: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        pasteOrientation: "Test string",
                        pasteType: "Test string",
                        source: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    createDeveloperMetadata: {
                        developerMetadata: {
                            location: {
                                dimensionRange: {
                                    dimension: "Test string",
                                    endIndex: 42,
                                    sheetId: 42,
                                    startIndex: 42,
                                },
                                locationType: "Test string",
                                sheetId: 42,
                                spreadsheet: true,
                            },
                            metadataId: 42,
                            metadataKey: "Test string",
                            metadataValue: "Test string",
                            visibility: "Test string",
                        },
                    },
                    cutPaste: {
                        destination: {
                            columnIndex: 42,
                            rowIndex: 42,
                            sheetId: 42,
                        },
                        pasteType: "Test string",
                        source: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    deleteBanding: {
                        bandedRangeId: 42,
                    },
                    deleteConditionalFormatRule: {
                        index: 42,
                        sheetId: 42,
                    },
                    deleteDeveloperMetadata: {
                        dataFilter: {
                            a1Range: "Test string",
                            developerMetadataLookup: {
                                locationMatchingStrategy: "Test string",
                                locationType: "Test string",
                                metadataId: 42,
                                metadataKey: "Test string",
                                metadataLocation: {
                                    dimensionRange: {
                                        dimension: "Test string",
                                        endIndex: 42,
                                        sheetId: 42,
                                        startIndex: 42,
                                    },
                                    locationType: "Test string",
                                    sheetId: 42,
                                    spreadsheet: true,
                                },
                                metadataValue: "Test string",
                                visibility: "Test string",
                            },
                            gridRange: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                        },
                    },
                    deleteDimension: {
                        range: {
                            dimension: "Test string",
                            endIndex: 42,
                            sheetId: 42,
                            startIndex: 42,
                        },
                    },
                    deleteDimensionGroup: {
                        range: {
                            dimension: "Test string",
                            endIndex: 42,
                            sheetId: 42,
                            startIndex: 42,
                        },
                    },
                    deleteDuplicates: {
                        comparisonColumns: [
                            {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            }                        ],
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    deleteEmbeddedObject: {
                        objectId: 42,
                    },
                    deleteFilterView: {
                        filterId: 42,
                    },
                    deleteNamedRange: {
                        namedRangeId: "Test string",
                    },
                    deleteProtectedRange: {
                        protectedRangeId: 42,
                    },
                    deleteRange: {
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        shiftDimension: "Test string",
                    },
                    deleteSheet: {
                        sheetId: 42,
                    },
                    duplicateFilterView: {
                        filterId: 42,
                    },
                    duplicateSheet: {
                        insertSheetIndex: 42,
                        newSheetId: 42,
                        newSheetName: "Test string",
                        sourceSheetId: 42,
                    },
                    findReplace: {
                        allSheets: true,
                        find: "Test string",
                        includeFormulas: true,
                        matchCase: true,
                        matchEntireCell: true,
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        replacement: "Test string",
                        searchByRegex: true,
                        sheetId: 42,
                    },
                    insertDimension: {
                        inheritFromBefore: true,
                        range: {
                            dimension: "Test string",
                            endIndex: 42,
                            sheetId: 42,
                            startIndex: 42,
                        },
                    },
                    insertRange: {
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        shiftDimension: "Test string",
                    },
                    mergeCells: {
                        mergeType: "Test string",
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    moveDimension: {
                        destinationIndex: 42,
                        source: {
                            dimension: "Test string",
                            endIndex: 42,
                            sheetId: 42,
                            startIndex: 42,
                        },
                    },
                    pasteData: {
                        coordinate: {
                            columnIndex: 42,
                            rowIndex: 42,
                            sheetId: 42,
                        },
                        data: "Test string",
                        delimiter: "Test string",
                        html: true,
                        type: "Test string",
                    },
                    randomizeRange: {
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    repeatCell: {
                        cell: {
                            dataValidation: {
                                condition: {
                                    type: "Test string",
                                    values: [
                                        {
                                            relativeDate: "Test string",
                                            userEnteredValue: "Test string",
                                        }                                    ],
                                },
                                inputMessage: "Test string",
                                showCustomUi: true,
                                strict: true,
                            },
                            effectiveFormat: {
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                borders: {
                                    bottom: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    left: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    right: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    top: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                },
                                horizontalAlignment: "Test string",
                                hyperlinkDisplayType: "Test string",
                                numberFormat: {
                                    pattern: "Test string",
                                    type: "Test string",
                                },
                                padding: {
                                    bottom: 42,
                                    left: 42,
                                    right: 42,
                                    top: 42,
                                },
                                textDirection: "Test string",
                                textFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                textRotation: {
                                    angle: 42,
                                    vertical: true,
                                },
                                verticalAlignment: "Test string",
                                wrapStrategy: "Test string",
                            },
                            effectiveValue: {
                                boolValue: true,
                                errorValue: {
                                    message: "Test string",
                                    type: "Test string",
                                },
                                formulaValue: "Test string",
                                numberValue: 42,
                                stringValue: "Test string",
                            },
                            formattedValue: "Test string",
                            hyperlink: "Test string",
                            note: "Test string",
                            pivotTable: {
                                columns: [
                                    {
                                        groupRule: {
                                            dateTimeRule: {
                                                type: "Test string",
                                            },
                                            histogramRule: {
                                                end: 42,
                                                interval: 42,
                                                start: 42,
                                            },
                                            manualRule: {
                                                groups: [
                                                    {
                                                        groupName: {
                                                            boolValue: true,
                                                            errorValue: {
                                                                message: "Test string",
                                                                type: "Test string",
                                                            },
                                                            formulaValue: "Test string",
                                                            numberValue: 42,
                                                            stringValue: "Test string",
                                                        },
                                                        items: [
                                                            {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            }                                                        ],
                                                    }                                                ],
                                            },
                                        },
                                        label: "Test string",
                                        repeatHeadings: true,
                                        showTotals: true,
                                        sortOrder: "Test string",
                                        sourceColumnOffset: 42,
                                        valueBucket: {
                                            buckets: [
                                                {
                                                    boolValue: true,
                                                    errorValue: {
                                                        message: "Test string",
                                                        type: "Test string",
                                                    },
                                                    formulaValue: "Test string",
                                                    numberValue: 42,
                                                    stringValue: "Test string",
                                                }                                            ],
                                            valuesIndex: 42,
                                        },
                                        valueMetadata: [
                                            {
                                                collapsed: true,
                                                value: {
                                                    boolValue: true,
                                                    errorValue: {
                                                        message: "Test string",
                                                        type: "Test string",
                                                    },
                                                    formulaValue: "Test string",
                                                    numberValue: 42,
                                                    stringValue: "Test string",
                                                },
                                            }                                        ],
                                    }                                ],
                                criteria: {
                                    A: {
                                        visibleValues: [
                                            "Test string"                                        ],
                                    }                                },
                                rows: [
                                    {
                                        groupRule: {
                                            dateTimeRule: {
                                                type: "Test string",
                                            },
                                            histogramRule: {
                                                end: 42,
                                                interval: 42,
                                                start: 42,
                                            },
                                            manualRule: {
                                                groups: [
                                                    {
                                                        groupName: {
                                                            boolValue: true,
                                                            errorValue: {
                                                                message: "Test string",
                                                                type: "Test string",
                                                            },
                                                            formulaValue: "Test string",
                                                            numberValue: 42,
                                                            stringValue: "Test string",
                                                        },
                                                        items: [
                                                            {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            }                                                        ],
                                                    }                                                ],
                                            },
                                        },
                                        label: "Test string",
                                        repeatHeadings: true,
                                        showTotals: true,
                                        sortOrder: "Test string",
                                        sourceColumnOffset: 42,
                                        valueBucket: {
                                            buckets: [
                                                {
                                                    boolValue: true,
                                                    errorValue: {
                                                        message: "Test string",
                                                        type: "Test string",
                                                    },
                                                    formulaValue: "Test string",
                                                    numberValue: 42,
                                                    stringValue: "Test string",
                                                }                                            ],
                                            valuesIndex: 42,
                                        },
                                        valueMetadata: [
                                            {
                                                collapsed: true,
                                                value: {
                                                    boolValue: true,
                                                    errorValue: {
                                                        message: "Test string",
                                                        type: "Test string",
                                                    },
                                                    formulaValue: "Test string",
                                                    numberValue: 42,
                                                    stringValue: "Test string",
                                                },
                                            }                                        ],
                                    }                                ],
                                source: {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                },
                                valueLayout: "Test string",
                                values: [
                                    {
                                        calculatedDisplayType: "Test string",
                                        formula: "Test string",
                                        name: "Test string",
                                        sourceColumnOffset: 42,
                                        summarizeFunction: "Test string",
                                    }                                ],
                            },
                            textFormatRuns: [
                                {
                                    format: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                    startIndex: 42,
                                }                            ],
                            userEnteredFormat: {
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                borders: {
                                    bottom: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    left: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    right: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    top: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                },
                                horizontalAlignment: "Test string",
                                hyperlinkDisplayType: "Test string",
                                numberFormat: {
                                    pattern: "Test string",
                                    type: "Test string",
                                },
                                padding: {
                                    bottom: 42,
                                    left: 42,
                                    right: 42,
                                    top: 42,
                                },
                                textDirection: "Test string",
                                textFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                textRotation: {
                                    angle: 42,
                                    vertical: true,
                                },
                                verticalAlignment: "Test string",
                                wrapStrategy: "Test string",
                            },
                            userEnteredValue: {
                                boolValue: true,
                                errorValue: {
                                    message: "Test string",
                                    type: "Test string",
                                },
                                formulaValue: "Test string",
                                numberValue: 42,
                                stringValue: "Test string",
                            },
                        },
                        fields: "Test string",
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    setBasicFilter: {
                        filter: {
                            criteria: {
                                A: {
                                    condition: {
                                        type: "Test string",
                                        values: [
                                            {
                                                relativeDate: "Test string",
                                                userEnteredValue: "Test string",
                                            }                                        ],
                                    },
                                    hiddenValues: [
                                        "Test string"                                    ],
                                    visibleBackgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleBackgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    visibleForegroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleForegroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                }                            },
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            sortSpecs: [
                                {
                                    backgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    backgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    dimensionIndex: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    sortOrder: "Test string",
                                }                            ],
                        },
                    },
                    setDataValidation: {
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        rule: {
                            condition: {
                                type: "Test string",
                                values: [
                                    {
                                        relativeDate: "Test string",
                                        userEnteredValue: "Test string",
                                    }                                ],
                            },
                            inputMessage: "Test string",
                            showCustomUi: true,
                            strict: true,
                        },
                    },
                    sortRange: {
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        sortSpecs: [
                            {
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                dimensionIndex: 42,
                                foregroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                foregroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                sortOrder: "Test string",
                            }                        ],
                    },
                    textToColumns: {
                        delimiter: "Test string",
                        delimiterType: "Test string",
                        source: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    trimWhitespace: {
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    unmergeCells: {
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    updateBanding: {
                        bandedRange: {
                            bandedRangeId: 42,
                            columnProperties: {
                                firstBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                firstBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                footerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                footerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                headerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                headerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                secondBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                secondBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                            },
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            rowProperties: {
                                firstBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                firstBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                footerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                footerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                headerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                headerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                secondBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                secondBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                            },
                        },
                        fields: "Test string",
                    },
                    updateBorders: {
                        bottom: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                        innerHorizontal: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                        innerVertical: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                        left: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        right: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                        top: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                    },
                    updateCells: {
                        fields: "Test string",
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        rows: [
                            {
                                values: [
                                    {
                                        dataValidation: {
                                            condition: {
                                                type: "Test string",
                                                values: [
                                                    {
                                                        relativeDate: "Test string",
                                                        userEnteredValue: "Test string",
                                                    }                                                ],
                                            },
                                            inputMessage: "Test string",
                                            showCustomUi: true,
                                            strict: true,
                                        },
                                        effectiveFormat: {
                                            backgroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            backgroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            borders: {
                                                bottom: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                left: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                right: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                top: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                            },
                                            horizontalAlignment: "Test string",
                                            hyperlinkDisplayType: "Test string",
                                            numberFormat: {
                                                pattern: "Test string",
                                                type: "Test string",
                                            },
                                            padding: {
                                                bottom: 42,
                                                left: 42,
                                                right: 42,
                                                top: 42,
                                            },
                                            textDirection: "Test string",
                                            textFormat: {
                                                bold: true,
                                                fontFamily: "Test string",
                                                fontSize: 42,
                                                foregroundColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                foregroundColorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                italic: true,
                                                strikethrough: true,
                                                underline: true,
                                            },
                                            textRotation: {
                                                angle: 42,
                                                vertical: true,
                                            },
                                            verticalAlignment: "Test string",
                                            wrapStrategy: "Test string",
                                        },
                                        effectiveValue: {
                                            boolValue: true,
                                            errorValue: {
                                                message: "Test string",
                                                type: "Test string",
                                            },
                                            formulaValue: "Test string",
                                            numberValue: 42,
                                            stringValue: "Test string",
                                        },
                                        formattedValue: "Test string",
                                        hyperlink: "Test string",
                                        note: "Test string",
                                        pivotTable: {
                                            columns: [
                                                {
                                                    groupRule: {
                                                        dateTimeRule: {
                                                            type: "Test string",
                                                        },
                                                        histogramRule: {
                                                            end: 42,
                                                            interval: 42,
                                                            start: 42,
                                                        },
                                                        manualRule: {
                                                            groups: [
                                                                {
                                                                    groupName: {
                                                                        boolValue: true,
                                                                        errorValue: {
                                                                            message: "Test string",
                                                                            type: "Test string",
                                                                        },
                                                                        formulaValue: "Test string",
                                                                        numberValue: 42,
                                                                        stringValue: "Test string",
                                                                    },
                                                                    items: [
                                                                        {
                                                                            boolValue: true,
                                                                            errorValue: {
                                                                                message: "Test string",
                                                                                type: "Test string",
                                                                            },
                                                                            formulaValue: "Test string",
                                                                            numberValue: 42,
                                                                            stringValue: "Test string",
                                                                        }                                                                    ],
                                                                }                                                            ],
                                                        },
                                                    },
                                                    label: "Test string",
                                                    repeatHeadings: true,
                                                    showTotals: true,
                                                    sortOrder: "Test string",
                                                    sourceColumnOffset: 42,
                                                    valueBucket: {
                                                        buckets: [
                                                            {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            }                                                        ],
                                                        valuesIndex: 42,
                                                    },
                                                    valueMetadata: [
                                                        {
                                                            collapsed: true,
                                                            value: {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            },
                                                        }                                                    ],
                                                }                                            ],
                                            criteria: {
                                                A: {
                                                    visibleValues: [
                                                        "Test string"                                                    ],
                                                }                                            },
                                            rows: [
                                                {
                                                    groupRule: {
                                                        dateTimeRule: {
                                                            type: "Test string",
                                                        },
                                                        histogramRule: {
                                                            end: 42,
                                                            interval: 42,
                                                            start: 42,
                                                        },
                                                        manualRule: {
                                                            groups: [
                                                                {
                                                                    groupName: {
                                                                        boolValue: true,
                                                                        errorValue: {
                                                                            message: "Test string",
                                                                            type: "Test string",
                                                                        },
                                                                        formulaValue: "Test string",
                                                                        numberValue: 42,
                                                                        stringValue: "Test string",
                                                                    },
                                                                    items: [
                                                                        {
                                                                            boolValue: true,
                                                                            errorValue: {
                                                                                message: "Test string",
                                                                                type: "Test string",
                                                                            },
                                                                            formulaValue: "Test string",
                                                                            numberValue: 42,
                                                                            stringValue: "Test string",
                                                                        }                                                                    ],
                                                                }                                                            ],
                                                        },
                                                    },
                                                    label: "Test string",
                                                    repeatHeadings: true,
                                                    showTotals: true,
                                                    sortOrder: "Test string",
                                                    sourceColumnOffset: 42,
                                                    valueBucket: {
                                                        buckets: [
                                                            {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            }                                                        ],
                                                        valuesIndex: 42,
                                                    },
                                                    valueMetadata: [
                                                        {
                                                            collapsed: true,
                                                            value: {
                                                                boolValue: true,
                                                                errorValue: {
                                                                    message: "Test string",
                                                                    type: "Test string",
                                                                },
                                                                formulaValue: "Test string",
                                                                numberValue: 42,
                                                                stringValue: "Test string",
                                                            },
                                                        }                                                    ],
                                                }                                            ],
                                            source: {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            },
                                            valueLayout: "Test string",
                                            values: [
                                                {
                                                    calculatedDisplayType: "Test string",
                                                    formula: "Test string",
                                                    name: "Test string",
                                                    sourceColumnOffset: 42,
                                                    summarizeFunction: "Test string",
                                                }                                            ],
                                        },
                                        textFormatRuns: [
                                            {
                                                format: {
                                                    bold: true,
                                                    fontFamily: "Test string",
                                                    fontSize: 42,
                                                    foregroundColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    foregroundColorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    italic: true,
                                                    strikethrough: true,
                                                    underline: true,
                                                },
                                                startIndex: 42,
                                            }                                        ],
                                        userEnteredFormat: {
                                            backgroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            backgroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            borders: {
                                                bottom: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                left: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                right: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                                top: {
                                                    color: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    colorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    style: "Test string",
                                                    width: 42,
                                                },
                                            },
                                            horizontalAlignment: "Test string",
                                            hyperlinkDisplayType: "Test string",
                                            numberFormat: {
                                                pattern: "Test string",
                                                type: "Test string",
                                            },
                                            padding: {
                                                bottom: 42,
                                                left: 42,
                                                right: 42,
                                                top: 42,
                                            },
                                            textDirection: "Test string",
                                            textFormat: {
                                                bold: true,
                                                fontFamily: "Test string",
                                                fontSize: 42,
                                                foregroundColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                foregroundColorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                italic: true,
                                                strikethrough: true,
                                                underline: true,
                                            },
                                            textRotation: {
                                                angle: 42,
                                                vertical: true,
                                            },
                                            verticalAlignment: "Test string",
                                            wrapStrategy: "Test string",
                                        },
                                        userEnteredValue: {
                                            boolValue: true,
                                            errorValue: {
                                                message: "Test string",
                                                type: "Test string",
                                            },
                                            formulaValue: "Test string",
                                            numberValue: 42,
                                            stringValue: "Test string",
                                        },
                                    }                                ],
                            }                        ],
                        start: {
                            columnIndex: 42,
                            rowIndex: 42,
                            sheetId: 42,
                        },
                    },
                    updateChartSpec: {
                        chartId: 42,
                        spec: {
                            altText: "Test string",
                            backgroundColor: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            backgroundColorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            basicChart: {
                                axis: [
                                    {
                                        format: {
                                            bold: true,
                                            fontFamily: "Test string",
                                            fontSize: 42,
                                            foregroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            foregroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            italic: true,
                                            strikethrough: true,
                                            underline: true,
                                        },
                                        position: "Test string",
                                        title: "Test string",
                                        titleTextPosition: {
                                            horizontalAlignment: "Test string",
                                        },
                                        viewWindowOptions: {
                                            viewWindowMax: 42,
                                            viewWindowMin: 42,
                                            viewWindowMode: "Test string",
                                        },
                                    }                                ],
                                chartType: "Test string",
                                compareMode: "Test string",
                                domains: [
                                    {
                                        domain: {
                                            sourceRange: {
                                                sources: [
                                                    {
                                                        endColumnIndex: 42,
                                                        endRowIndex: 42,
                                                        sheetId: 42,
                                                        startColumnIndex: 42,
                                                        startRowIndex: 42,
                                                    }                                                ],
                                            },
                                        },
                                        reversed: true,
                                    }                                ],
                                headerCount: 42,
                                interpolateNulls: true,
                                legendPosition: "Test string",
                                lineSmoothing: true,
                                series: [
                                    {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        lineStyle: {
                                            type: "Test string",
                                            width: 42,
                                        },
                                        series: {
                                            sourceRange: {
                                                sources: [
                                                    {
                                                        endColumnIndex: 42,
                                                        endRowIndex: 42,
                                                        sheetId: 42,
                                                        startColumnIndex: 42,
                                                        startRowIndex: 42,
                                                    }                                                ],
                                            },
                                        },
                                        targetAxis: "Test string",
                                        type: "Test string",
                                    }                                ],
                                stackedType: "Test string",
                                threeDimensional: true,
                            },
                            bubbleChart: {
                                bubbleBorderColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                bubbleBorderColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                bubbleLabels: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                bubbleMaxRadiusSize: 42,
                                bubbleMinRadiusSize: 42,
                                bubbleOpacity: 42,
                                bubbleSizes: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                bubbleTextStyle: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                domain: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                groupIds: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                legendPosition: "Test string",
                                series: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                            },
                            candlestickChart: {
                                data: [
                                    {
                                        closeSeries: {
                                            data: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                        },
                                        highSeries: {
                                            data: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                        },
                                        lowSeries: {
                                            data: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                        },
                                        openSeries: {
                                            data: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                        },
                                    }                                ],
                                domain: {
                                    data: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    reversed: true,
                                },
                            },
                            fontName: "Test string",
                            hiddenDimensionStrategy: "Test string",
                            histogramChart: {
                                bucketSize: 42,
                                legendPosition: "Test string",
                                outlierPercentile: 42,
                                series: [
                                    {
                                        barColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        barColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        data: {
                                            sourceRange: {
                                                sources: [
                                                    {
                                                        endColumnIndex: 42,
                                                        endRowIndex: 42,
                                                        sheetId: 42,
                                                        startColumnIndex: 42,
                                                        startRowIndex: 42,
                                                    }                                                ],
                                            },
                                        },
                                    }                                ],
                                showItemDividers: true,
                            },
                            maximized: true,
                            orgChart: {
                                labels: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                nodeColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                nodeColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                nodeSize: "Test string",
                                parentLabels: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                selectedNodeColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                selectedNodeColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                tooltips: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                            },
                            pieChart: {
                                domain: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                legendPosition: "Test string",
                                pieHole: 42,
                                series: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                threeDimensional: true,
                            },
                            scorecardChart: {
                                aggregateType: "Test string",
                                baselineValueData: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                baselineValueFormat: {
                                    comparisonType: "Test string",
                                    description: "Test string",
                                    negativeColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    negativeColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    position: {
                                        horizontalAlignment: "Test string",
                                    },
                                    positiveColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    positiveColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    textFormat: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                },
                                customFormatOptions: {
                                    prefix: "Test string",
                                    suffix: "Test string",
                                },
                                keyValueData: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                keyValueFormat: {
                                    position: {
                                        horizontalAlignment: "Test string",
                                    },
                                    textFormat: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                },
                                numberFormatSource: "Test string",
                                scaleFactor: 42,
                            },
                            subtitle: "Test string",
                            subtitleTextFormat: {
                                bold: true,
                                fontFamily: "Test string",
                                fontSize: 42,
                                foregroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                foregroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                italic: true,
                                strikethrough: true,
                                underline: true,
                            },
                            subtitleTextPosition: {
                                horizontalAlignment: "Test string",
                            },
                            title: "Test string",
                            titleTextFormat: {
                                bold: true,
                                fontFamily: "Test string",
                                fontSize: 42,
                                foregroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                foregroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                italic: true,
                                strikethrough: true,
                                underline: true,
                            },
                            titleTextPosition: {
                                horizontalAlignment: "Test string",
                            },
                            treemapChart: {
                                colorData: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                colorScale: {
                                    maxValueColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    maxValueColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    midValueColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    midValueColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    minValueColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    minValueColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    noDataColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    noDataColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                },
                                headerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                headerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                hideTooltips: true,
                                hintedLevels: 42,
                                labels: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                levels: 42,
                                maxValue: 42,
                                minValue: 42,
                                parentLabels: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                sizeData: {
                                    sourceRange: {
                                        sources: [
                                            {
                                                endColumnIndex: 42,
                                                endRowIndex: 42,
                                                sheetId: 42,
                                                startColumnIndex: 42,
                                                startRowIndex: 42,
                                            }                                        ],
                                    },
                                },
                                textFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                            },
                            waterfallChart: {
                                connectorLineStyle: {
                                    type: "Test string",
                                    width: 42,
                                },
                                domain: {
                                    data: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    reversed: true,
                                },
                                firstValueIsTotal: true,
                                hideConnectorLines: true,
                                series: [
                                    {
                                        customSubtotals: [
                                            {
                                                dataIsSubtotal: true,
                                                label: "Test string",
                                                subtotalIndex: 42,
                                            }                                        ],
                                        data: {
                                            sourceRange: {
                                                sources: [
                                                    {
                                                        endColumnIndex: 42,
                                                        endRowIndex: 42,
                                                        sheetId: 42,
                                                        startColumnIndex: 42,
                                                        startRowIndex: 42,
                                                    }                                                ],
                                            },
                                        },
                                        hideTrailingSubtotal: true,
                                        negativeColumnsStyle: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            label: "Test string",
                                        },
                                        positiveColumnsStyle: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            label: "Test string",
                                        },
                                        subtotalColumnsStyle: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            label: "Test string",
                                        },
                                    }                                ],
                                stackedType: "Test string",
                            },
                        },
                    },
                    updateConditionalFormatRule: {
                        index: 42,
                        newIndex: 42,
                        rule: {
                            booleanRule: {
                                condition: {
                                    type: "Test string",
                                    values: [
                                        {
                                            relativeDate: "Test string",
                                            userEnteredValue: "Test string",
                                        }                                    ],
                                },
                                format: {
                                    backgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    backgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    borders: {
                                        bottom: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        left: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        right: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        top: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                    },
                                    horizontalAlignment: "Test string",
                                    hyperlinkDisplayType: "Test string",
                                    numberFormat: {
                                        pattern: "Test string",
                                        type: "Test string",
                                    },
                                    padding: {
                                        bottom: 42,
                                        left: 42,
                                        right: 42,
                                        top: 42,
                                    },
                                    textDirection: "Test string",
                                    textFormat: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                    textRotation: {
                                        angle: 42,
                                        vertical: true,
                                    },
                                    verticalAlignment: "Test string",
                                    wrapStrategy: "Test string",
                                },
                            },
                            gradientRule: {
                                maxpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                                midpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                                minpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                            },
                            ranges: [
                                {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                }                            ],
                        },
                        sheetId: 42,
                    },
                    updateDeveloperMetadata: {
                        dataFilters: [
                            {
                                a1Range: "Test string",
                                developerMetadataLookup: {
                                    locationMatchingStrategy: "Test string",
                                    locationType: "Test string",
                                    metadataId: 42,
                                    metadataKey: "Test string",
                                    metadataLocation: {
                                        dimensionRange: {
                                            dimension: "Test string",
                                            endIndex: 42,
                                            sheetId: 42,
                                            startIndex: 42,
                                        },
                                        locationType: "Test string",
                                        sheetId: 42,
                                        spreadsheet: true,
                                    },
                                    metadataValue: "Test string",
                                    visibility: "Test string",
                                },
                                gridRange: {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                },
                            }                        ],
                        developerMetadata: {
                            location: {
                                dimensionRange: {
                                    dimension: "Test string",
                                    endIndex: 42,
                                    sheetId: 42,
                                    startIndex: 42,
                                },
                                locationType: "Test string",
                                sheetId: 42,
                                spreadsheet: true,
                            },
                            metadataId: 42,
                            metadataKey: "Test string",
                            metadataValue: "Test string",
                            visibility: "Test string",
                        },
                        fields: "Test string",
                    },
                    updateDimensionGroup: {
                        dimensionGroup: {
                            collapsed: true,
                            depth: 42,
                            range: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                        },
                        fields: "Test string",
                    },
                    updateDimensionProperties: {
                        fields: "Test string",
                        properties: {
                            developerMetadata: [
                                {
                                    location: {
                                        dimensionRange: {
                                            dimension: "Test string",
                                            endIndex: 42,
                                            sheetId: 42,
                                            startIndex: 42,
                                        },
                                        locationType: "Test string",
                                        sheetId: 42,
                                        spreadsheet: true,
                                    },
                                    metadataId: 42,
                                    metadataKey: "Test string",
                                    metadataValue: "Test string",
                                    visibility: "Test string",
                                }                            ],
                            hiddenByFilter: true,
                            hiddenByUser: true,
                            pixelSize: 42,
                        },
                        range: {
                            dimension: "Test string",
                            endIndex: 42,
                            sheetId: 42,
                            startIndex: 42,
                        },
                    },
                    updateEmbeddedObjectPosition: {
                        fields: "Test string",
                        newPosition: {
                            newSheet: true,
                            overlayPosition: {
                                anchorCell: {
                                    columnIndex: 42,
                                    rowIndex: 42,
                                    sheetId: 42,
                                },
                                heightPixels: 42,
                                offsetXPixels: 42,
                                offsetYPixels: 42,
                                widthPixels: 42,
                            },
                            sheetId: 42,
                        },
                        objectId: 42,
                    },
                    updateFilterView: {
                        fields: "Test string",
                        filter: {
                            criteria: {
                                A: {
                                    condition: {
                                        type: "Test string",
                                        values: [
                                            {
                                                relativeDate: "Test string",
                                                userEnteredValue: "Test string",
                                            }                                        ],
                                    },
                                    hiddenValues: [
                                        "Test string"                                    ],
                                    visibleBackgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleBackgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    visibleForegroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleForegroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                }                            },
                            filterViewId: 42,
                            namedRangeId: "Test string",
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            sortSpecs: [
                                {
                                    backgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    backgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    dimensionIndex: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    sortOrder: "Test string",
                                }                            ],
                            title: "Test string",
                        },
                    },
                    updateNamedRange: {
                        fields: "Test string",
                        namedRange: {
                            name: "Test string",
                            namedRangeId: "Test string",
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                        },
                    },
                    updateProtectedRange: {
                        fields: "Test string",
                        protectedRange: {
                            description: "Test string",
                            editors: {
                                domainUsersCanEdit: true,
                                groups: [
                                    "Test string"                                ],
                                users: [
                                    "Test string"                                ],
                            },
                            namedRangeId: "Test string",
                            protectedRangeId: 42,
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            requestingUserCanEdit: true,
                            unprotectedRanges: [
                                {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                }                            ],
                            warningOnly: true,
                        },
                    },
                    updateSheetProperties: {
                        fields: "Test string",
                        properties: {
                            gridProperties: {
                                columnCount: 42,
                                columnGroupControlAfter: true,
                                frozenColumnCount: 42,
                                frozenRowCount: 42,
                                hideGridlines: true,
                                rowCount: 42,
                                rowGroupControlAfter: true,
                            },
                            hidden: true,
                            index: 42,
                            rightToLeft: true,
                            sheetId: 42,
                            sheetType: "Test string",
                            tabColor: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            tabColorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            title: "Test string",
                        },
                    },
                    updateSlicerSpec: {
                        fields: "Test string",
                        slicerId: 42,
                        spec: {
                            applyToPivotTables: true,
                            backgroundColor: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            backgroundColorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            columnIndex: 42,
                            dataRange: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            filterCriteria: {
                                condition: {
                                    type: "Test string",
                                    values: [
                                        {
                                            relativeDate: "Test string",
                                            userEnteredValue: "Test string",
                                        }                                    ],
                                },
                                hiddenValues: [
                                    "Test string"                                ],
                                visibleBackgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                visibleBackgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                visibleForegroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                visibleForegroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                            },
                            horizontalAlignment: "Test string",
                            textFormat: {
                                bold: true,
                                fontFamily: "Test string",
                                fontSize: 42,
                                foregroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                foregroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                italic: true,
                                strikethrough: true,
                                underline: true,
                            },
                            title: "Test string",
                        },
                    },
                    updateSpreadsheetProperties: {
                        fields: "Test string",
                        properties: {
                            autoRecalc: "Test string",
                            defaultFormat: {
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                borders: {
                                    bottom: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    left: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    right: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                    top: {
                                        color: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        colorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        style: "Test string",
                                        width: 42,
                                    },
                                },
                                horizontalAlignment: "Test string",
                                hyperlinkDisplayType: "Test string",
                                numberFormat: {
                                    pattern: "Test string",
                                    type: "Test string",
                                },
                                padding: {
                                    bottom: 42,
                                    left: 42,
                                    right: 42,
                                    top: 42,
                                },
                                textDirection: "Test string",
                                textFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                textRotation: {
                                    angle: 42,
                                    vertical: true,
                                },
                                verticalAlignment: "Test string",
                                wrapStrategy: "Test string",
                            },
                            iterativeCalculationSettings: {
                                convergenceThreshold: 42,
                                maxIterations: 42,
                            },
                            locale: "Test string",
                            spreadsheetTheme: {
                                primaryFontFamily: "Test string",
                                themeColors: [
                                    {
                                        color: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        colorType: "Test string",
                                    }                                ],
                            },
                            timeZone: "Test string",
                            title: "Test string",
                        },
                    },
                }            ],
            responseIncludeGridData: true,
            responseRanges: [
                "Test string"            ],
        });
        /**
         * Returns the developer metadata with the specified ID.
         * The caller must specify the spreadsheet ID and the developer metadata's
         * unique metadataId.
         */
        await gapi.client.sheets.spreadsheets.developerMetadata.get({
            metadataId: 42,
            spreadsheetId: "Test string",
        });
        /**
         * Returns all developer metadata matching the specified DataFilter.
         * If the provided DataFilter represents a DeveloperMetadataLookup object,
         * this will return all DeveloperMetadata entries selected by it. If the
         * DataFilter represents a location in a spreadsheet, this will return all
         * developer metadata associated with locations intersecting that region.
         */
        await gapi.client.sheets.spreadsheets.developerMetadata.search({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
        });
        /**
         * Copies a single sheet from a spreadsheet to another spreadsheet.
         * Returns the properties of the newly created sheet.
         */
        await gapi.client.sheets.spreadsheets.sheets.copyTo({
            sheetId: 42,
            spreadsheetId: "Test string",
        }, {
            destinationSpreadsheetId: "Test string",
        });
        /**
         * Appends values to a spreadsheet. The input range is used to search for
         * existing data and find a "table" within that range. Values will be
         * appended to the next row of the table, starting with the first column of
         * the table. See the
         * [guide](/sheets/api/guides/values#appending_values)
         * and
         * [sample code](/sheets/api/samples/writing#append_values)
         * for specific details of how tables are detected and data is appended.
         *
         * The caller must specify the spreadsheet ID, range, and
         * a valueInputOption.  The `valueInputOption` only
         * controls how the input data will be added to the sheet (column-wise or
         * row-wise), it does not influence what cell the data starts being written
         * to.
         */
        await gapi.client.sheets.spreadsheets.values.append({
            includeValuesInResponse: true,
            insertDataOption: "Test string",
            range: "Test string",
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            spreadsheetId: "Test string",
            valueInputOption: "Test string",
        }, {
            majorDimension: "Test string",
            range: "Test string",
            values: [
                [
                    42                ]            ],
        });
        /**
         * Clears one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more ranges.
         * Only values are cleared -- all other properties of the cell (such as
         * formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.batchClear({
            spreadsheetId: "Test string",
        }, {
            ranges: [
                "Test string"            ],
        });
        /**
         * Clears one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more
         * DataFilters. Ranges matching any of the specified data
         * filters will be cleared.  Only values are cleared -- all other properties
         * of the cell (such as formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.batchClearByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
        });
        /**
         * Returns one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more ranges.
         */
        await gapi.client.sheets.spreadsheets.values.batchGet({
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            ranges: "Test string",
            spreadsheetId: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Returns one or more ranges of values that match the specified data filters.
         * The caller must specify the spreadsheet ID and one or more
         * DataFilters.  Ranges that match any of the data filters in
         * the request will be returned.
         */
        await gapi.client.sheets.spreadsheets.values.batchGetByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Sets values in one or more ranges of a spreadsheet.
         * The caller must specify the spreadsheet ID,
         * a valueInputOption, and one or more
         * ValueRanges.
         */
        await gapi.client.sheets.spreadsheets.values.batchUpdate({
            spreadsheetId: "Test string",
        }, {
            data: [
                {
                    majorDimension: "Test string",
                    range: "Test string",
                    values: [
                        [
                            42                        ]                    ],
                }            ],
            includeValuesInResponse: true,
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            valueInputOption: "Test string",
        });
        /**
         * Sets values in one or more ranges of a spreadsheet.
         * The caller must specify the spreadsheet ID,
         * a valueInputOption, and one or more
         * DataFilterValueRanges.
         */
        await gapi.client.sheets.spreadsheets.values.batchUpdateByDataFilter({
            spreadsheetId: "Test string",
        }, {
            data: [
                {
                    dataFilter: {
                        a1Range: "Test string",
                        developerMetadataLookup: {
                            locationMatchingStrategy: "Test string",
                            locationType: "Test string",
                            metadataId: 42,
                            metadataKey: "Test string",
                            metadataLocation: {
                                dimensionRange: {
                                    dimension: "Test string",
                                    endIndex: 42,
                                    sheetId: 42,
                                    startIndex: 42,
                                },
                                locationType: "Test string",
                                sheetId: 42,
                                spreadsheet: true,
                            },
                            metadataValue: "Test string",
                            visibility: "Test string",
                        },
                        gridRange: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    majorDimension: "Test string",
                    values: [
                        [
                            42                        ]                    ],
                }            ],
            includeValuesInResponse: true,
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            valueInputOption: "Test string",
        });
        /**
         * Clears values from a spreadsheet.
         * The caller must specify the spreadsheet ID and range.
         * Only values are cleared -- all other properties of the cell (such as
         * formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.clear({
            range: "Test string",
            spreadsheetId: "Test string",
        }, {
        });
        /**
         * Returns a range of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and a range.
         */
        await gapi.client.sheets.spreadsheets.values.get({
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            range: "Test string",
            spreadsheetId: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Sets values in a range of a spreadsheet.
         * The caller must specify the spreadsheet ID, range, and
         * a valueInputOption.
         */
        await gapi.client.sheets.spreadsheets.values.update({
            includeValuesInResponse: true,
            range: "Test string",
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            spreadsheetId: "Test string",
            valueInputOption: "Test string",
        }, {
            majorDimension: "Test string",
            range: "Test string",
            values: [
                [
                    42                ]            ],
        });
        /** Creates a spreadsheet, returning the newly created spreadsheet. */
        await gapi.client.sheets.spreadsheets.create({
        }, {
            developerMetadata: [
                {
                    location: {
                        dimensionRange: {
                            dimension: "Test string",
                            endIndex: 42,
                            sheetId: 42,
                            startIndex: 42,
                        },
                        locationType: "Test string",
                        sheetId: 42,
                        spreadsheet: true,
                    },
                    metadataId: 42,
                    metadataKey: "Test string",
                    metadataValue: "Test string",
                    visibility: "Test string",
                }            ],
            namedRanges: [
                {
                    name: "Test string",
                    namedRangeId: "Test string",
                    range: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
            properties: {
                autoRecalc: "Test string",
                defaultFormat: {
                    backgroundColor: {
                        alpha: 42,
                        blue: 42,
                        green: 42,
                        red: 42,
                    },
                    backgroundColorStyle: {
                        rgbColor: {
                            alpha: 42,
                            blue: 42,
                            green: 42,
                            red: 42,
                        },
                        themeColor: "Test string",
                    },
                    borders: {
                        bottom: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                        left: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                        right: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                        top: {
                            color: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            colorStyle: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            style: "Test string",
                            width: 42,
                        },
                    },
                    horizontalAlignment: "Test string",
                    hyperlinkDisplayType: "Test string",
                    numberFormat: {
                        pattern: "Test string",
                        type: "Test string",
                    },
                    padding: {
                        bottom: 42,
                        left: 42,
                        right: 42,
                        top: 42,
                    },
                    textDirection: "Test string",
                    textFormat: {
                        bold: true,
                        fontFamily: "Test string",
                        fontSize: 42,
                        foregroundColor: {
                            alpha: 42,
                            blue: 42,
                            green: 42,
                            red: 42,
                        },
                        foregroundColorStyle: {
                            rgbColor: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            themeColor: "Test string",
                        },
                        italic: true,
                        strikethrough: true,
                        underline: true,
                    },
                    textRotation: {
                        angle: 42,
                        vertical: true,
                    },
                    verticalAlignment: "Test string",
                    wrapStrategy: "Test string",
                },
                iterativeCalculationSettings: {
                    convergenceThreshold: 42,
                    maxIterations: 42,
                },
                locale: "Test string",
                spreadsheetTheme: {
                    primaryFontFamily: "Test string",
                    themeColors: [
                        {
                            color: {
                                rgbColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                themeColor: "Test string",
                            },
                            colorType: "Test string",
                        }                    ],
                },
                timeZone: "Test string",
                title: "Test string",
            },
            sheets: [
                {
                    bandedRanges: [
                        {
                            bandedRangeId: 42,
                            columnProperties: {
                                firstBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                firstBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                footerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                footerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                headerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                headerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                secondBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                secondBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                            },
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            rowProperties: {
                                firstBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                firstBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                footerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                footerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                headerColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                headerColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                secondBandColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                secondBandColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                            },
                        }                    ],
                    basicFilter: {
                        criteria: {
                            A: {
                                condition: {
                                    type: "Test string",
                                    values: [
                                        {
                                            relativeDate: "Test string",
                                            userEnteredValue: "Test string",
                                        }                                    ],
                                },
                                hiddenValues: [
                                    "Test string"                                ],
                                visibleBackgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                visibleBackgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                visibleForegroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                visibleForegroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                            }                        },
                        range: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                        sortSpecs: [
                            {
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                dimensionIndex: 42,
                                foregroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                foregroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                sortOrder: "Test string",
                            }                        ],
                    },
                    charts: [
                        {
                            chartId: 42,
                            position: {
                                newSheet: true,
                                overlayPosition: {
                                    anchorCell: {
                                        columnIndex: 42,
                                        rowIndex: 42,
                                        sheetId: 42,
                                    },
                                    heightPixels: 42,
                                    offsetXPixels: 42,
                                    offsetYPixels: 42,
                                    widthPixels: 42,
                                },
                                sheetId: 42,
                            },
                            spec: {
                                altText: "Test string",
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                basicChart: {
                                    axis: [
                                        {
                                            format: {
                                                bold: true,
                                                fontFamily: "Test string",
                                                fontSize: 42,
                                                foregroundColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                foregroundColorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                italic: true,
                                                strikethrough: true,
                                                underline: true,
                                            },
                                            position: "Test string",
                                            title: "Test string",
                                            titleTextPosition: {
                                                horizontalAlignment: "Test string",
                                            },
                                            viewWindowOptions: {
                                                viewWindowMax: 42,
                                                viewWindowMin: 42,
                                                viewWindowMode: "Test string",
                                            },
                                        }                                    ],
                                    chartType: "Test string",
                                    compareMode: "Test string",
                                    domains: [
                                        {
                                            domain: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                            reversed: true,
                                        }                                    ],
                                    headerCount: 42,
                                    interpolateNulls: true,
                                    legendPosition: "Test string",
                                    lineSmoothing: true,
                                    series: [
                                        {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            lineStyle: {
                                                type: "Test string",
                                                width: 42,
                                            },
                                            series: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                            targetAxis: "Test string",
                                            type: "Test string",
                                        }                                    ],
                                    stackedType: "Test string",
                                    threeDimensional: true,
                                },
                                bubbleChart: {
                                    bubbleBorderColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    bubbleBorderColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    bubbleLabels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    bubbleMaxRadiusSize: 42,
                                    bubbleMinRadiusSize: 42,
                                    bubbleOpacity: 42,
                                    bubbleSizes: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    bubbleTextStyle: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                    domain: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    groupIds: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    legendPosition: "Test string",
                                    series: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                },
                                candlestickChart: {
                                    data: [
                                        {
                                            closeSeries: {
                                                data: {
                                                    sourceRange: {
                                                        sources: [
                                                            {
                                                                endColumnIndex: 42,
                                                                endRowIndex: 42,
                                                                sheetId: 42,
                                                                startColumnIndex: 42,
                                                                startRowIndex: 42,
                                                            }                                                        ],
                                                    },
                                                },
                                            },
                                            highSeries: {
                                                data: {
                                                    sourceRange: {
                                                        sources: [
                                                            {
                                                                endColumnIndex: 42,
                                                                endRowIndex: 42,
                                                                sheetId: 42,
                                                                startColumnIndex: 42,
                                                                startRowIndex: 42,
                                                            }                                                        ],
                                                    },
                                                },
                                            },
                                            lowSeries: {
                                                data: {
                                                    sourceRange: {
                                                        sources: [
                                                            {
                                                                endColumnIndex: 42,
                                                                endRowIndex: 42,
                                                                sheetId: 42,
                                                                startColumnIndex: 42,
                                                                startRowIndex: 42,
                                                            }                                                        ],
                                                    },
                                                },
                                            },
                                            openSeries: {
                                                data: {
                                                    sourceRange: {
                                                        sources: [
                                                            {
                                                                endColumnIndex: 42,
                                                                endRowIndex: 42,
                                                                sheetId: 42,
                                                                startColumnIndex: 42,
                                                                startRowIndex: 42,
                                                            }                                                        ],
                                                    },
                                                },
                                            },
                                        }                                    ],
                                    domain: {
                                        data: {
                                            sourceRange: {
                                                sources: [
                                                    {
                                                        endColumnIndex: 42,
                                                        endRowIndex: 42,
                                                        sheetId: 42,
                                                        startColumnIndex: 42,
                                                        startRowIndex: 42,
                                                    }                                                ],
                                            },
                                        },
                                        reversed: true,
                                    },
                                },
                                fontName: "Test string",
                                hiddenDimensionStrategy: "Test string",
                                histogramChart: {
                                    bucketSize: 42,
                                    legendPosition: "Test string",
                                    outlierPercentile: 42,
                                    series: [
                                        {
                                            barColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            barColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            data: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                        }                                    ],
                                    showItemDividers: true,
                                },
                                maximized: true,
                                orgChart: {
                                    labels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    nodeColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    nodeColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    nodeSize: "Test string",
                                    parentLabels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    selectedNodeColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    selectedNodeColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    tooltips: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                },
                                pieChart: {
                                    domain: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    legendPosition: "Test string",
                                    pieHole: 42,
                                    series: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    threeDimensional: true,
                                },
                                scorecardChart: {
                                    aggregateType: "Test string",
                                    baselineValueData: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    baselineValueFormat: {
                                        comparisonType: "Test string",
                                        description: "Test string",
                                        negativeColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        negativeColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        position: {
                                            horizontalAlignment: "Test string",
                                        },
                                        positiveColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        positiveColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        textFormat: {
                                            bold: true,
                                            fontFamily: "Test string",
                                            fontSize: 42,
                                            foregroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            foregroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            italic: true,
                                            strikethrough: true,
                                            underline: true,
                                        },
                                    },
                                    customFormatOptions: {
                                        prefix: "Test string",
                                        suffix: "Test string",
                                    },
                                    keyValueData: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    keyValueFormat: {
                                        position: {
                                            horizontalAlignment: "Test string",
                                        },
                                        textFormat: {
                                            bold: true,
                                            fontFamily: "Test string",
                                            fontSize: 42,
                                            foregroundColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            foregroundColorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            italic: true,
                                            strikethrough: true,
                                            underline: true,
                                        },
                                    },
                                    numberFormatSource: "Test string",
                                    scaleFactor: 42,
                                },
                                subtitle: "Test string",
                                subtitleTextFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                subtitleTextPosition: {
                                    horizontalAlignment: "Test string",
                                },
                                title: "Test string",
                                titleTextFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                titleTextPosition: {
                                    horizontalAlignment: "Test string",
                                },
                                treemapChart: {
                                    colorData: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    colorScale: {
                                        maxValueColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        maxValueColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        midValueColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        midValueColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        minValueColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        minValueColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        noDataColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        noDataColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                    },
                                    headerColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    headerColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    hideTooltips: true,
                                    hintedLevels: 42,
                                    labels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    levels: 42,
                                    maxValue: 42,
                                    minValue: 42,
                                    parentLabels: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    sizeData: {
                                        sourceRange: {
                                            sources: [
                                                {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                }                                            ],
                                        },
                                    },
                                    textFormat: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                },
                                waterfallChart: {
                                    connectorLineStyle: {
                                        type: "Test string",
                                        width: 42,
                                    },
                                    domain: {
                                        data: {
                                            sourceRange: {
                                                sources: [
                                                    {
                                                        endColumnIndex: 42,
                                                        endRowIndex: 42,
                                                        sheetId: 42,
                                                        startColumnIndex: 42,
                                                        startRowIndex: 42,
                                                    }                                                ],
                                            },
                                        },
                                        reversed: true,
                                    },
                                    firstValueIsTotal: true,
                                    hideConnectorLines: true,
                                    series: [
                                        {
                                            customSubtotals: [
                                                {
                                                    dataIsSubtotal: true,
                                                    label: "Test string",
                                                    subtotalIndex: 42,
                                                }                                            ],
                                            data: {
                                                sourceRange: {
                                                    sources: [
                                                        {
                                                            endColumnIndex: 42,
                                                            endRowIndex: 42,
                                                            sheetId: 42,
                                                            startColumnIndex: 42,
                                                            startRowIndex: 42,
                                                        }                                                    ],
                                                },
                                            },
                                            hideTrailingSubtotal: true,
                                            negativeColumnsStyle: {
                                                color: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                colorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                label: "Test string",
                                            },
                                            positiveColumnsStyle: {
                                                color: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                colorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                label: "Test string",
                                            },
                                            subtotalColumnsStyle: {
                                                color: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                colorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                label: "Test string",
                                            },
                                        }                                    ],
                                    stackedType: "Test string",
                                },
                            },
                        }                    ],
                    columnGroups: [
                        {
                            collapsed: true,
                            depth: 42,
                            range: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                        }                    ],
                    conditionalFormats: [
                        {
                            booleanRule: {
                                condition: {
                                    type: "Test string",
                                    values: [
                                        {
                                            relativeDate: "Test string",
                                            userEnteredValue: "Test string",
                                        }                                    ],
                                },
                                format: {
                                    backgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    backgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    borders: {
                                        bottom: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        left: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        right: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                        top: {
                                            color: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            colorStyle: {
                                                rgbColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                themeColor: "Test string",
                                            },
                                            style: "Test string",
                                            width: 42,
                                        },
                                    },
                                    horizontalAlignment: "Test string",
                                    hyperlinkDisplayType: "Test string",
                                    numberFormat: {
                                        pattern: "Test string",
                                        type: "Test string",
                                    },
                                    padding: {
                                        bottom: 42,
                                        left: 42,
                                        right: 42,
                                        top: 42,
                                    },
                                    textDirection: "Test string",
                                    textFormat: {
                                        bold: true,
                                        fontFamily: "Test string",
                                        fontSize: 42,
                                        foregroundColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        foregroundColorStyle: {
                                            rgbColor: {
                                                alpha: 42,
                                                blue: 42,
                                                green: 42,
                                                red: 42,
                                            },
                                            themeColor: "Test string",
                                        },
                                        italic: true,
                                        strikethrough: true,
                                        underline: true,
                                    },
                                    textRotation: {
                                        angle: 42,
                                        vertical: true,
                                    },
                                    verticalAlignment: "Test string",
                                    wrapStrategy: "Test string",
                                },
                            },
                            gradientRule: {
                                maxpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                                midpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                                minpoint: {
                                    color: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    colorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    type: "Test string",
                                    value: "Test string",
                                },
                            },
                            ranges: [
                                {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                }                            ],
                        }                    ],
                    data: [
                        {
                            columnMetadata: [
                                {
                                    developerMetadata: [
                                        {
                                            location: {
                                                dimensionRange: {
                                                    dimension: "Test string",
                                                    endIndex: 42,
                                                    sheetId: 42,
                                                    startIndex: 42,
                                                },
                                                locationType: "Test string",
                                                sheetId: 42,
                                                spreadsheet: true,
                                            },
                                            metadataId: 42,
                                            metadataKey: "Test string",
                                            metadataValue: "Test string",
                                            visibility: "Test string",
                                        }                                    ],
                                    hiddenByFilter: true,
                                    hiddenByUser: true,
                                    pixelSize: 42,
                                }                            ],
                            rowData: [
                                {
                                    values: [
                                        {
                                            dataValidation: {
                                                condition: {
                                                    type: "Test string",
                                                    values: [
                                                        {
                                                            relativeDate: "Test string",
                                                            userEnteredValue: "Test string",
                                                        }                                                    ],
                                                },
                                                inputMessage: "Test string",
                                                showCustomUi: true,
                                                strict: true,
                                            },
                                            effectiveFormat: {
                                                backgroundColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                backgroundColorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                borders: {
                                                    bottom: {
                                                        color: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        colorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        style: "Test string",
                                                        width: 42,
                                                    },
                                                    left: {
                                                        color: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        colorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        style: "Test string",
                                                        width: 42,
                                                    },
                                                    right: {
                                                        color: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        colorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        style: "Test string",
                                                        width: 42,
                                                    },
                                                    top: {
                                                        color: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        colorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        style: "Test string",
                                                        width: 42,
                                                    },
                                                },
                                                horizontalAlignment: "Test string",
                                                hyperlinkDisplayType: "Test string",
                                                numberFormat: {
                                                    pattern: "Test string",
                                                    type: "Test string",
                                                },
                                                padding: {
                                                    bottom: 42,
                                                    left: 42,
                                                    right: 42,
                                                    top: 42,
                                                },
                                                textDirection: "Test string",
                                                textFormat: {
                                                    bold: true,
                                                    fontFamily: "Test string",
                                                    fontSize: 42,
                                                    foregroundColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    foregroundColorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    italic: true,
                                                    strikethrough: true,
                                                    underline: true,
                                                },
                                                textRotation: {
                                                    angle: 42,
                                                    vertical: true,
                                                },
                                                verticalAlignment: "Test string",
                                                wrapStrategy: "Test string",
                                            },
                                            effectiveValue: {
                                                boolValue: true,
                                                errorValue: {
                                                    message: "Test string",
                                                    type: "Test string",
                                                },
                                                formulaValue: "Test string",
                                                numberValue: 42,
                                                stringValue: "Test string",
                                            },
                                            formattedValue: "Test string",
                                            hyperlink: "Test string",
                                            note: "Test string",
                                            pivotTable: {
                                                columns: [
                                                    {
                                                        groupRule: {
                                                            dateTimeRule: {
                                                                type: "Test string",
                                                            },
                                                            histogramRule: {
                                                                end: 42,
                                                                interval: 42,
                                                                start: 42,
                                                            },
                                                            manualRule: {
                                                                groups: [
                                                                    {
                                                                        groupName: {
                                                                            boolValue: true,
                                                                            errorValue: {
                                                                                message: "Test string",
                                                                                type: "Test string",
                                                                            },
                                                                            formulaValue: "Test string",
                                                                            numberValue: 42,
                                                                            stringValue: "Test string",
                                                                        },
                                                                        items: [
                                                                            {
                                                                                boolValue: true,
                                                                                errorValue: {
                                                                                    message: "Test string",
                                                                                    type: "Test string",
                                                                                },
                                                                                formulaValue: "Test string",
                                                                                numberValue: 42,
                                                                                stringValue: "Test string",
                                                                            }                                                                        ],
                                                                    }                                                                ],
                                                            },
                                                        },
                                                        label: "Test string",
                                                        repeatHeadings: true,
                                                        showTotals: true,
                                                        sortOrder: "Test string",
                                                        sourceColumnOffset: 42,
                                                        valueBucket: {
                                                            buckets: [
                                                                {
                                                                    boolValue: true,
                                                                    errorValue: {
                                                                        message: "Test string",
                                                                        type: "Test string",
                                                                    },
                                                                    formulaValue: "Test string",
                                                                    numberValue: 42,
                                                                    stringValue: "Test string",
                                                                }                                                            ],
                                                            valuesIndex: 42,
                                                        },
                                                        valueMetadata: [
                                                            {
                                                                collapsed: true,
                                                                value: {
                                                                    boolValue: true,
                                                                    errorValue: {
                                                                        message: "Test string",
                                                                        type: "Test string",
                                                                    },
                                                                    formulaValue: "Test string",
                                                                    numberValue: 42,
                                                                    stringValue: "Test string",
                                                                },
                                                            }                                                        ],
                                                    }                                                ],
                                                criteria: {
                                                    A: {
                                                        visibleValues: [
                                                            "Test string"                                                        ],
                                                    }                                                },
                                                rows: [
                                                    {
                                                        groupRule: {
                                                            dateTimeRule: {
                                                                type: "Test string",
                                                            },
                                                            histogramRule: {
                                                                end: 42,
                                                                interval: 42,
                                                                start: 42,
                                                            },
                                                            manualRule: {
                                                                groups: [
                                                                    {
                                                                        groupName: {
                                                                            boolValue: true,
                                                                            errorValue: {
                                                                                message: "Test string",
                                                                                type: "Test string",
                                                                            },
                                                                            formulaValue: "Test string",
                                                                            numberValue: 42,
                                                                            stringValue: "Test string",
                                                                        },
                                                                        items: [
                                                                            {
                                                                                boolValue: true,
                                                                                errorValue: {
                                                                                    message: "Test string",
                                                                                    type: "Test string",
                                                                                },
                                                                                formulaValue: "Test string",
                                                                                numberValue: 42,
                                                                                stringValue: "Test string",
                                                                            }                                                                        ],
                                                                    }                                                                ],
                                                            },
                                                        },
                                                        label: "Test string",
                                                        repeatHeadings: true,
                                                        showTotals: true,
                                                        sortOrder: "Test string",
                                                        sourceColumnOffset: 42,
                                                        valueBucket: {
                                                            buckets: [
                                                                {
                                                                    boolValue: true,
                                                                    errorValue: {
                                                                        message: "Test string",
                                                                        type: "Test string",
                                                                    },
                                                                    formulaValue: "Test string",
                                                                    numberValue: 42,
                                                                    stringValue: "Test string",
                                                                }                                                            ],
                                                            valuesIndex: 42,
                                                        },
                                                        valueMetadata: [
                                                            {
                                                                collapsed: true,
                                                                value: {
                                                                    boolValue: true,
                                                                    errorValue: {
                                                                        message: "Test string",
                                                                        type: "Test string",
                                                                    },
                                                                    formulaValue: "Test string",
                                                                    numberValue: 42,
                                                                    stringValue: "Test string",
                                                                },
                                                            }                                                        ],
                                                    }                                                ],
                                                source: {
                                                    endColumnIndex: 42,
                                                    endRowIndex: 42,
                                                    sheetId: 42,
                                                    startColumnIndex: 42,
                                                    startRowIndex: 42,
                                                },
                                                valueLayout: "Test string",
                                                values: [
                                                    {
                                                        calculatedDisplayType: "Test string",
                                                        formula: "Test string",
                                                        name: "Test string",
                                                        sourceColumnOffset: 42,
                                                        summarizeFunction: "Test string",
                                                    }                                                ],
                                            },
                                            textFormatRuns: [
                                                {
                                                    format: {
                                                        bold: true,
                                                        fontFamily: "Test string",
                                                        fontSize: 42,
                                                        foregroundColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        foregroundColorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        italic: true,
                                                        strikethrough: true,
                                                        underline: true,
                                                    },
                                                    startIndex: 42,
                                                }                                            ],
                                            userEnteredFormat: {
                                                backgroundColor: {
                                                    alpha: 42,
                                                    blue: 42,
                                                    green: 42,
                                                    red: 42,
                                                },
                                                backgroundColorStyle: {
                                                    rgbColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    themeColor: "Test string",
                                                },
                                                borders: {
                                                    bottom: {
                                                        color: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        colorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        style: "Test string",
                                                        width: 42,
                                                    },
                                                    left: {
                                                        color: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        colorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        style: "Test string",
                                                        width: 42,
                                                    },
                                                    right: {
                                                        color: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        colorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        style: "Test string",
                                                        width: 42,
                                                    },
                                                    top: {
                                                        color: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        colorStyle: {
                                                            rgbColor: {
                                                                alpha: 42,
                                                                blue: 42,
                                                                green: 42,
                                                                red: 42,
                                                            },
                                                            themeColor: "Test string",
                                                        },
                                                        style: "Test string",
                                                        width: 42,
                                                    },
                                                },
                                                horizontalAlignment: "Test string",
                                                hyperlinkDisplayType: "Test string",
                                                numberFormat: {
                                                    pattern: "Test string",
                                                    type: "Test string",
                                                },
                                                padding: {
                                                    bottom: 42,
                                                    left: 42,
                                                    right: 42,
                                                    top: 42,
                                                },
                                                textDirection: "Test string",
                                                textFormat: {
                                                    bold: true,
                                                    fontFamily: "Test string",
                                                    fontSize: 42,
                                                    foregroundColor: {
                                                        alpha: 42,
                                                        blue: 42,
                                                        green: 42,
                                                        red: 42,
                                                    },
                                                    foregroundColorStyle: {
                                                        rgbColor: {
                                                            alpha: 42,
                                                            blue: 42,
                                                            green: 42,
                                                            red: 42,
                                                        },
                                                        themeColor: "Test string",
                                                    },
                                                    italic: true,
                                                    strikethrough: true,
                                                    underline: true,
                                                },
                                                textRotation: {
                                                    angle: 42,
                                                    vertical: true,
                                                },
                                                verticalAlignment: "Test string",
                                                wrapStrategy: "Test string",
                                            },
                                            userEnteredValue: {
                                                boolValue: true,
                                                errorValue: {
                                                    message: "Test string",
                                                    type: "Test string",
                                                },
                                                formulaValue: "Test string",
                                                numberValue: 42,
                                                stringValue: "Test string",
                                            },
                                        }                                    ],
                                }                            ],
                            rowMetadata: [
                                {
                                    developerMetadata: [
                                        {
                                            location: {
                                                dimensionRange: {
                                                    dimension: "Test string",
                                                    endIndex: 42,
                                                    sheetId: 42,
                                                    startIndex: 42,
                                                },
                                                locationType: "Test string",
                                                sheetId: 42,
                                                spreadsheet: true,
                                            },
                                            metadataId: 42,
                                            metadataKey: "Test string",
                                            metadataValue: "Test string",
                                            visibility: "Test string",
                                        }                                    ],
                                    hiddenByFilter: true,
                                    hiddenByUser: true,
                                    pixelSize: 42,
                                }                            ],
                            startColumn: 42,
                            startRow: 42,
                        }                    ],
                    developerMetadata: [
                        {
                            location: {
                                dimensionRange: {
                                    dimension: "Test string",
                                    endIndex: 42,
                                    sheetId: 42,
                                    startIndex: 42,
                                },
                                locationType: "Test string",
                                sheetId: 42,
                                spreadsheet: true,
                            },
                            metadataId: 42,
                            metadataKey: "Test string",
                            metadataValue: "Test string",
                            visibility: "Test string",
                        }                    ],
                    filterViews: [
                        {
                            criteria: {
                                A: {
                                    condition: {
                                        type: "Test string",
                                        values: [
                                            {
                                                relativeDate: "Test string",
                                                userEnteredValue: "Test string",
                                            }                                        ],
                                    },
                                    hiddenValues: [
                                        "Test string"                                    ],
                                    visibleBackgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleBackgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    visibleForegroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleForegroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                }                            },
                            filterViewId: 42,
                            namedRangeId: "Test string",
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            sortSpecs: [
                                {
                                    backgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    backgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    dimensionIndex: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    sortOrder: "Test string",
                                }                            ],
                            title: "Test string",
                        }                    ],
                    merges: [
                        {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        }                    ],
                    properties: {
                        gridProperties: {
                            columnCount: 42,
                            columnGroupControlAfter: true,
                            frozenColumnCount: 42,
                            frozenRowCount: 42,
                            hideGridlines: true,
                            rowCount: 42,
                            rowGroupControlAfter: true,
                        },
                        hidden: true,
                        index: 42,
                        rightToLeft: true,
                        sheetId: 42,
                        sheetType: "Test string",
                        tabColor: {
                            alpha: 42,
                            blue: 42,
                            green: 42,
                            red: 42,
                        },
                        tabColorStyle: {
                            rgbColor: {
                                alpha: 42,
                                blue: 42,
                                green: 42,
                                red: 42,
                            },
                            themeColor: "Test string",
                        },
                        title: "Test string",
                    },
                    protectedRanges: [
                        {
                            description: "Test string",
                            editors: {
                                domainUsersCanEdit: true,
                                groups: [
                                    "Test string"                                ],
                                users: [
                                    "Test string"                                ],
                            },
                            namedRangeId: "Test string",
                            protectedRangeId: 42,
                            range: {
                                endColumnIndex: 42,
                                endRowIndex: 42,
                                sheetId: 42,
                                startColumnIndex: 42,
                                startRowIndex: 42,
                            },
                            requestingUserCanEdit: true,
                            unprotectedRanges: [
                                {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                }                            ],
                            warningOnly: true,
                        }                    ],
                    rowGroups: [
                        {
                            collapsed: true,
                            depth: 42,
                            range: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                        }                    ],
                    slicers: [
                        {
                            position: {
                                newSheet: true,
                                overlayPosition: {
                                    anchorCell: {
                                        columnIndex: 42,
                                        rowIndex: 42,
                                        sheetId: 42,
                                    },
                                    heightPixels: 42,
                                    offsetXPixels: 42,
                                    offsetYPixels: 42,
                                    widthPixels: 42,
                                },
                                sheetId: 42,
                            },
                            slicerId: 42,
                            spec: {
                                applyToPivotTables: true,
                                backgroundColor: {
                                    alpha: 42,
                                    blue: 42,
                                    green: 42,
                                    red: 42,
                                },
                                backgroundColorStyle: {
                                    rgbColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    themeColor: "Test string",
                                },
                                columnIndex: 42,
                                dataRange: {
                                    endColumnIndex: 42,
                                    endRowIndex: 42,
                                    sheetId: 42,
                                    startColumnIndex: 42,
                                    startRowIndex: 42,
                                },
                                filterCriteria: {
                                    condition: {
                                        type: "Test string",
                                        values: [
                                            {
                                                relativeDate: "Test string",
                                                userEnteredValue: "Test string",
                                            }                                        ],
                                    },
                                    hiddenValues: [
                                        "Test string"                                    ],
                                    visibleBackgroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleBackgroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    visibleForegroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    visibleForegroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                },
                                horizontalAlignment: "Test string",
                                textFormat: {
                                    bold: true,
                                    fontFamily: "Test string",
                                    fontSize: 42,
                                    foregroundColor: {
                                        alpha: 42,
                                        blue: 42,
                                        green: 42,
                                        red: 42,
                                    },
                                    foregroundColorStyle: {
                                        rgbColor: {
                                            alpha: 42,
                                            blue: 42,
                                            green: 42,
                                            red: 42,
                                        },
                                        themeColor: "Test string",
                                    },
                                    italic: true,
                                    strikethrough: true,
                                    underline: true,
                                },
                                title: "Test string",
                            },
                        }                    ],
                }            ],
            spreadsheetId: "Test string",
            spreadsheetUrl: "Test string",
        });
        /**
         * Returns the developer metadata with the specified ID.
         * The caller must specify the spreadsheet ID and the developer metadata's
         * unique metadataId.
         */
        await gapi.client.sheets.spreadsheets.developerMetadata.get({
            metadataId: 42,
            spreadsheetId: "Test string",
        });
        /**
         * Returns all developer metadata matching the specified DataFilter.
         * If the provided DataFilter represents a DeveloperMetadataLookup object,
         * this will return all DeveloperMetadata entries selected by it. If the
         * DataFilter represents a location in a spreadsheet, this will return all
         * developer metadata associated with locations intersecting that region.
         */
        await gapi.client.sheets.spreadsheets.developerMetadata.search({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
        });
        /**
         * Copies a single sheet from a spreadsheet to another spreadsheet.
         * Returns the properties of the newly created sheet.
         */
        await gapi.client.sheets.spreadsheets.sheets.copyTo({
            sheetId: 42,
            spreadsheetId: "Test string",
        }, {
            destinationSpreadsheetId: "Test string",
        });
        /**
         * Appends values to a spreadsheet. The input range is used to search for
         * existing data and find a "table" within that range. Values will be
         * appended to the next row of the table, starting with the first column of
         * the table. See the
         * [guide](/sheets/api/guides/values#appending_values)
         * and
         * [sample code](/sheets/api/samples/writing#append_values)
         * for specific details of how tables are detected and data is appended.
         *
         * The caller must specify the spreadsheet ID, range, and
         * a valueInputOption.  The `valueInputOption` only
         * controls how the input data will be added to the sheet (column-wise or
         * row-wise), it does not influence what cell the data starts being written
         * to.
         */
        await gapi.client.sheets.spreadsheets.values.append({
            includeValuesInResponse: true,
            insertDataOption: "Test string",
            range: "Test string",
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            spreadsheetId: "Test string",
            valueInputOption: "Test string",
        }, {
            majorDimension: "Test string",
            range: "Test string",
            values: [
                [
                    42                ]            ],
        });
        /**
         * Clears one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more ranges.
         * Only values are cleared -- all other properties of the cell (such as
         * formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.batchClear({
            spreadsheetId: "Test string",
        }, {
            ranges: [
                "Test string"            ],
        });
        /**
         * Clears one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more
         * DataFilters. Ranges matching any of the specified data
         * filters will be cleared.  Only values are cleared -- all other properties
         * of the cell (such as formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.batchClearByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
        });
        /**
         * Returns one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more ranges.
         */
        await gapi.client.sheets.spreadsheets.values.batchGet({
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            ranges: "Test string",
            spreadsheetId: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Returns one or more ranges of values that match the specified data filters.
         * The caller must specify the spreadsheet ID and one or more
         * DataFilters.  Ranges that match any of the data filters in
         * the request will be returned.
         */
        await gapi.client.sheets.spreadsheets.values.batchGetByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Sets values in one or more ranges of a spreadsheet.
         * The caller must specify the spreadsheet ID,
         * a valueInputOption, and one or more
         * ValueRanges.
         */
        await gapi.client.sheets.spreadsheets.values.batchUpdate({
            spreadsheetId: "Test string",
        }, {
            data: [
                {
                    majorDimension: "Test string",
                    range: "Test string",
                    values: [
                        [
                            42                        ]                    ],
                }            ],
            includeValuesInResponse: true,
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            valueInputOption: "Test string",
        });
        /**
         * Sets values in one or more ranges of a spreadsheet.
         * The caller must specify the spreadsheet ID,
         * a valueInputOption, and one or more
         * DataFilterValueRanges.
         */
        await gapi.client.sheets.spreadsheets.values.batchUpdateByDataFilter({
            spreadsheetId: "Test string",
        }, {
            data: [
                {
                    dataFilter: {
                        a1Range: "Test string",
                        developerMetadataLookup: {
                            locationMatchingStrategy: "Test string",
                            locationType: "Test string",
                            metadataId: 42,
                            metadataKey: "Test string",
                            metadataLocation: {
                                dimensionRange: {
                                    dimension: "Test string",
                                    endIndex: 42,
                                    sheetId: 42,
                                    startIndex: 42,
                                },
                                locationType: "Test string",
                                sheetId: 42,
                                spreadsheet: true,
                            },
                            metadataValue: "Test string",
                            visibility: "Test string",
                        },
                        gridRange: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    majorDimension: "Test string",
                    values: [
                        [
                            42                        ]                    ],
                }            ],
            includeValuesInResponse: true,
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            valueInputOption: "Test string",
        });
        /**
         * Clears values from a spreadsheet.
         * The caller must specify the spreadsheet ID and range.
         * Only values are cleared -- all other properties of the cell (such as
         * formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.clear({
            range: "Test string",
            spreadsheetId: "Test string",
        }, {
        });
        /**
         * Returns a range of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and a range.
         */
        await gapi.client.sheets.spreadsheets.values.get({
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            range: "Test string",
            spreadsheetId: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Sets values in a range of a spreadsheet.
         * The caller must specify the spreadsheet ID, range, and
         * a valueInputOption.
         */
        await gapi.client.sheets.spreadsheets.values.update({
            includeValuesInResponse: true,
            range: "Test string",
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            spreadsheetId: "Test string",
            valueInputOption: "Test string",
        }, {
            majorDimension: "Test string",
            range: "Test string",
            values: [
                [
                    42                ]            ],
        });
        /**
         * Returns the spreadsheet at the given ID.
         * The caller must specify the spreadsheet ID.
         *
         * By default, data within grids will not be returned.
         * You can include grid data one of two ways:
         *
         * &#42; Specify a field mask listing your desired fields using the `fields` URL
         * parameter in HTTP
         *
         * &#42; Set the includeGridData
         * URL parameter to true.  If a field mask is set, the `includeGridData`
         * parameter is ignored
         *
         * For large spreadsheets, it is recommended to retrieve only the specific
         * fields of the spreadsheet that you want.
         *
         * To retrieve only subsets of the spreadsheet, use the
         * ranges URL parameter.
         * Multiple ranges can be specified.  Limiting the range will
         * return only the portions of the spreadsheet that intersect the requested
         * ranges. Ranges are specified using A1 notation.
         */
        await gapi.client.sheets.spreadsheets.get({
            includeGridData: true,
            ranges: "Test string",
            spreadsheetId: "Test string",
        });
        /**
         * Returns the developer metadata with the specified ID.
         * The caller must specify the spreadsheet ID and the developer metadata's
         * unique metadataId.
         */
        await gapi.client.sheets.spreadsheets.developerMetadata.get({
            metadataId: 42,
            spreadsheetId: "Test string",
        });
        /**
         * Returns all developer metadata matching the specified DataFilter.
         * If the provided DataFilter represents a DeveloperMetadataLookup object,
         * this will return all DeveloperMetadata entries selected by it. If the
         * DataFilter represents a location in a spreadsheet, this will return all
         * developer metadata associated with locations intersecting that region.
         */
        await gapi.client.sheets.spreadsheets.developerMetadata.search({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
        });
        /**
         * Copies a single sheet from a spreadsheet to another spreadsheet.
         * Returns the properties of the newly created sheet.
         */
        await gapi.client.sheets.spreadsheets.sheets.copyTo({
            sheetId: 42,
            spreadsheetId: "Test string",
        }, {
            destinationSpreadsheetId: "Test string",
        });
        /**
         * Appends values to a spreadsheet. The input range is used to search for
         * existing data and find a "table" within that range. Values will be
         * appended to the next row of the table, starting with the first column of
         * the table. See the
         * [guide](/sheets/api/guides/values#appending_values)
         * and
         * [sample code](/sheets/api/samples/writing#append_values)
         * for specific details of how tables are detected and data is appended.
         *
         * The caller must specify the spreadsheet ID, range, and
         * a valueInputOption.  The `valueInputOption` only
         * controls how the input data will be added to the sheet (column-wise or
         * row-wise), it does not influence what cell the data starts being written
         * to.
         */
        await gapi.client.sheets.spreadsheets.values.append({
            includeValuesInResponse: true,
            insertDataOption: "Test string",
            range: "Test string",
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            spreadsheetId: "Test string",
            valueInputOption: "Test string",
        }, {
            majorDimension: "Test string",
            range: "Test string",
            values: [
                [
                    42                ]            ],
        });
        /**
         * Clears one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more ranges.
         * Only values are cleared -- all other properties of the cell (such as
         * formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.batchClear({
            spreadsheetId: "Test string",
        }, {
            ranges: [
                "Test string"            ],
        });
        /**
         * Clears one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more
         * DataFilters. Ranges matching any of the specified data
         * filters will be cleared.  Only values are cleared -- all other properties
         * of the cell (such as formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.batchClearByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
        });
        /**
         * Returns one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more ranges.
         */
        await gapi.client.sheets.spreadsheets.values.batchGet({
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            ranges: "Test string",
            spreadsheetId: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Returns one or more ranges of values that match the specified data filters.
         * The caller must specify the spreadsheet ID and one or more
         * DataFilters.  Ranges that match any of the data filters in
         * the request will be returned.
         */
        await gapi.client.sheets.spreadsheets.values.batchGetByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Sets values in one or more ranges of a spreadsheet.
         * The caller must specify the spreadsheet ID,
         * a valueInputOption, and one or more
         * ValueRanges.
         */
        await gapi.client.sheets.spreadsheets.values.batchUpdate({
            spreadsheetId: "Test string",
        }, {
            data: [
                {
                    majorDimension: "Test string",
                    range: "Test string",
                    values: [
                        [
                            42                        ]                    ],
                }            ],
            includeValuesInResponse: true,
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            valueInputOption: "Test string",
        });
        /**
         * Sets values in one or more ranges of a spreadsheet.
         * The caller must specify the spreadsheet ID,
         * a valueInputOption, and one or more
         * DataFilterValueRanges.
         */
        await gapi.client.sheets.spreadsheets.values.batchUpdateByDataFilter({
            spreadsheetId: "Test string",
        }, {
            data: [
                {
                    dataFilter: {
                        a1Range: "Test string",
                        developerMetadataLookup: {
                            locationMatchingStrategy: "Test string",
                            locationType: "Test string",
                            metadataId: 42,
                            metadataKey: "Test string",
                            metadataLocation: {
                                dimensionRange: {
                                    dimension: "Test string",
                                    endIndex: 42,
                                    sheetId: 42,
                                    startIndex: 42,
                                },
                                locationType: "Test string",
                                sheetId: 42,
                                spreadsheet: true,
                            },
                            metadataValue: "Test string",
                            visibility: "Test string",
                        },
                        gridRange: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    majorDimension: "Test string",
                    values: [
                        [
                            42                        ]                    ],
                }            ],
            includeValuesInResponse: true,
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            valueInputOption: "Test string",
        });
        /**
         * Clears values from a spreadsheet.
         * The caller must specify the spreadsheet ID and range.
         * Only values are cleared -- all other properties of the cell (such as
         * formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.clear({
            range: "Test string",
            spreadsheetId: "Test string",
        }, {
        });
        /**
         * Returns a range of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and a range.
         */
        await gapi.client.sheets.spreadsheets.values.get({
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            range: "Test string",
            spreadsheetId: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Sets values in a range of a spreadsheet.
         * The caller must specify the spreadsheet ID, range, and
         * a valueInputOption.
         */
        await gapi.client.sheets.spreadsheets.values.update({
            includeValuesInResponse: true,
            range: "Test string",
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            spreadsheetId: "Test string",
            valueInputOption: "Test string",
        }, {
            majorDimension: "Test string",
            range: "Test string",
            values: [
                [
                    42                ]            ],
        });
        /**
         * Returns the spreadsheet at the given ID.
         * The caller must specify the spreadsheet ID.
         *
         * This method differs from GetSpreadsheet in that it allows selecting
         * which subsets of spreadsheet data to return by specifying a
         * dataFilters parameter.
         * Multiple DataFilters can be specified.  Specifying one or
         * more data filters will return the portions of the spreadsheet that
         * intersect ranges matched by any of the filters.
         *
         * By default, data within grids will not be returned.
         * You can include grid data one of two ways:
         *
         * &#42; Specify a field mask listing your desired fields using the `fields` URL
         * parameter in HTTP
         *
         * &#42; Set the includeGridData
         * parameter to true.  If a field mask is set, the `includeGridData`
         * parameter is ignored
         *
         * For large spreadsheets, it is recommended to retrieve only the specific
         * fields of the spreadsheet that you want.
         */
        await gapi.client.sheets.spreadsheets.getByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
            includeGridData: true,
        });
        /**
         * Returns the developer metadata with the specified ID.
         * The caller must specify the spreadsheet ID and the developer metadata's
         * unique metadataId.
         */
        await gapi.client.sheets.spreadsheets.developerMetadata.get({
            metadataId: 42,
            spreadsheetId: "Test string",
        });
        /**
         * Returns all developer metadata matching the specified DataFilter.
         * If the provided DataFilter represents a DeveloperMetadataLookup object,
         * this will return all DeveloperMetadata entries selected by it. If the
         * DataFilter represents a location in a spreadsheet, this will return all
         * developer metadata associated with locations intersecting that region.
         */
        await gapi.client.sheets.spreadsheets.developerMetadata.search({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
        });
        /**
         * Copies a single sheet from a spreadsheet to another spreadsheet.
         * Returns the properties of the newly created sheet.
         */
        await gapi.client.sheets.spreadsheets.sheets.copyTo({
            sheetId: 42,
            spreadsheetId: "Test string",
        }, {
            destinationSpreadsheetId: "Test string",
        });
        /**
         * Appends values to a spreadsheet. The input range is used to search for
         * existing data and find a "table" within that range. Values will be
         * appended to the next row of the table, starting with the first column of
         * the table. See the
         * [guide](/sheets/api/guides/values#appending_values)
         * and
         * [sample code](/sheets/api/samples/writing#append_values)
         * for specific details of how tables are detected and data is appended.
         *
         * The caller must specify the spreadsheet ID, range, and
         * a valueInputOption.  The `valueInputOption` only
         * controls how the input data will be added to the sheet (column-wise or
         * row-wise), it does not influence what cell the data starts being written
         * to.
         */
        await gapi.client.sheets.spreadsheets.values.append({
            includeValuesInResponse: true,
            insertDataOption: "Test string",
            range: "Test string",
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            spreadsheetId: "Test string",
            valueInputOption: "Test string",
        }, {
            majorDimension: "Test string",
            range: "Test string",
            values: [
                [
                    42                ]            ],
        });
        /**
         * Clears one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more ranges.
         * Only values are cleared -- all other properties of the cell (such as
         * formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.batchClear({
            spreadsheetId: "Test string",
        }, {
            ranges: [
                "Test string"            ],
        });
        /**
         * Clears one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more
         * DataFilters. Ranges matching any of the specified data
         * filters will be cleared.  Only values are cleared -- all other properties
         * of the cell (such as formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.batchClearByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
        });
        /**
         * Returns one or more ranges of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and one or more ranges.
         */
        await gapi.client.sheets.spreadsheets.values.batchGet({
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            ranges: "Test string",
            spreadsheetId: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Returns one or more ranges of values that match the specified data filters.
         * The caller must specify the spreadsheet ID and one or more
         * DataFilters.  Ranges that match any of the data filters in
         * the request will be returned.
         */
        await gapi.client.sheets.spreadsheets.values.batchGetByDataFilter({
            spreadsheetId: "Test string",
        }, {
            dataFilters: [
                {
                    a1Range: "Test string",
                    developerMetadataLookup: {
                        locationMatchingStrategy: "Test string",
                        locationType: "Test string",
                        metadataId: 42,
                        metadataKey: "Test string",
                        metadataLocation: {
                            dimensionRange: {
                                dimension: "Test string",
                                endIndex: 42,
                                sheetId: 42,
                                startIndex: 42,
                            },
                            locationType: "Test string",
                            sheetId: 42,
                            spreadsheet: true,
                        },
                        metadataValue: "Test string",
                        visibility: "Test string",
                    },
                    gridRange: {
                        endColumnIndex: 42,
                        endRowIndex: 42,
                        sheetId: 42,
                        startColumnIndex: 42,
                        startRowIndex: 42,
                    },
                }            ],
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Sets values in one or more ranges of a spreadsheet.
         * The caller must specify the spreadsheet ID,
         * a valueInputOption, and one or more
         * ValueRanges.
         */
        await gapi.client.sheets.spreadsheets.values.batchUpdate({
            spreadsheetId: "Test string",
        }, {
            data: [
                {
                    majorDimension: "Test string",
                    range: "Test string",
                    values: [
                        [
                            42                        ]                    ],
                }            ],
            includeValuesInResponse: true,
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            valueInputOption: "Test string",
        });
        /**
         * Sets values in one or more ranges of a spreadsheet.
         * The caller must specify the spreadsheet ID,
         * a valueInputOption, and one or more
         * DataFilterValueRanges.
         */
        await gapi.client.sheets.spreadsheets.values.batchUpdateByDataFilter({
            spreadsheetId: "Test string",
        }, {
            data: [
                {
                    dataFilter: {
                        a1Range: "Test string",
                        developerMetadataLookup: {
                            locationMatchingStrategy: "Test string",
                            locationType: "Test string",
                            metadataId: 42,
                            metadataKey: "Test string",
                            metadataLocation: {
                                dimensionRange: {
                                    dimension: "Test string",
                                    endIndex: 42,
                                    sheetId: 42,
                                    startIndex: 42,
                                },
                                locationType: "Test string",
                                sheetId: 42,
                                spreadsheet: true,
                            },
                            metadataValue: "Test string",
                            visibility: "Test string",
                        },
                        gridRange: {
                            endColumnIndex: 42,
                            endRowIndex: 42,
                            sheetId: 42,
                            startColumnIndex: 42,
                            startRowIndex: 42,
                        },
                    },
                    majorDimension: "Test string",
                    values: [
                        [
                            42                        ]                    ],
                }            ],
            includeValuesInResponse: true,
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            valueInputOption: "Test string",
        });
        /**
         * Clears values from a spreadsheet.
         * The caller must specify the spreadsheet ID and range.
         * Only values are cleared -- all other properties of the cell (such as
         * formatting, data validation, etc..) are kept.
         */
        await gapi.client.sheets.spreadsheets.values.clear({
            range: "Test string",
            spreadsheetId: "Test string",
        }, {
        });
        /**
         * Returns a range of values from a spreadsheet.
         * The caller must specify the spreadsheet ID and a range.
         */
        await gapi.client.sheets.spreadsheets.values.get({
            dateTimeRenderOption: "Test string",
            majorDimension: "Test string",
            range: "Test string",
            spreadsheetId: "Test string",
            valueRenderOption: "Test string",
        });
        /**
         * Sets values in a range of a spreadsheet.
         * The caller must specify the spreadsheet ID, range, and
         * a valueInputOption.
         */
        await gapi.client.sheets.spreadsheets.values.update({
            includeValuesInResponse: true,
            range: "Test string",
            responseDateTimeRenderOption: "Test string",
            responseValueRenderOption: "Test string",
            spreadsheetId: "Test string",
            valueInputOption: "Test string",
        }, {
            majorDimension: "Test string",
            range: "Test string",
            values: [
                [
                    42                ]            ],
        });
    }
});
